#!/usr/bin/wish -f

########################################################
###                                                  ###
###            CCCM GUI TCL/TK SCRIPT                ###
###                                                  ###
###           `EDIT' CCM INPUT SCRIPT                ###
###                                                  ###
###           @COPYRIGHT DAMIAN FARNELL              ###
###                                                  ###
###         Tue Jul 16 14:30:44 BST 2002             ###
###                                                  ###
########################################################

set Font1 -*-Helvetica-Bold-R-Normal--*-220-*-*-*-*-*-*
set Font7 -*-Helvetica-Medium-R-Normal--*-140-*-*-*-*-*-*
set Font2 -*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-*
set Font3 -Adobe-Courier-Bold-R-Normal--*-150-*-*-*-*-*-*
set Font4 -Adobe-Courier-Bold-R-Normal--*-180-*-*-*-*-*-*
set Font5 -Adobe-Courier-Bold-R-Normal--*-180-*-*-*-*-*-*
set Font6 -Adobe-Courier-Bold-R-Normal--*-120-*-*-*-*-*-*

if {$argc != 2} {
    error "User must input two arguments to edit.tcl..."
}

# variables input from ccm tcl script

set script [lindex $argv 0]
set path   [lindex $argv 1]
set fname sub8-8 
set tempPath $path

# check that everything's working OK.

# top level parameters

set output 0
set dimension 1 
set spin 0.5 
set bounding 30 	
set n 8
set m 8 
set bonds 2 

# unit cell

set unitCell_number 1 

set unitCell_x(1) 0.0 
set unitCell_y(1) 0.0 
set unitCell_z(1) 0.0 
set unitCell_s(1) 0.5

set unitCell_x(2) 0.0 
set unitCell_y(2) 0.0 
set unitCell_z(2) 0.0 
set unitCell_s(2) 0.5

set unitCell_x(3) 0.0 
set unitCell_y(3) 0.0 
set unitCell_z(3) 0.0 
set unitCell_s(3) 0.5

set unitCell_x(4) 0.0 
set unitCell_y(4) 0.0 
set unitCell_z(4) 0.0 
set unitCell_s(4) 0.5

set unitCell_x(5) 0.0 
set unitCell_y(5) 0.0 
set unitCell_z(5) 0.0 
set unitCell_s(5) 0.5

set unitCell_x(6) 0.0 
set unitCell_y(6) 0.0 
set unitCell_z(6) 0.0 
set unitCell_s(6) 0.5

set bravaisLattice_a(1) 1.0
set bravaisLattice_a(2) 0.0
set bravaisLattice_a(3) 0.0
set bravaisLattice_b(1) 0.0
set bravaisLattice_b(2) 1.0
set bravaisLattice_b(3) 0.0
set bravaisLattice_c(1) 0.0
set bravaisLattice_c(2) 0.0
set bravaisLattice_c(3) 1.0

set minimum 0.0
set maximum 2.0
set increment 0.001000
set minimumy -2.0
set maximumy 0.0

set directional 0

for {set i 1} {$i < 7} {incr i} {

    set dummy5  [format \
	    "set latticeNeighbours_number(%d) 1" $i]

    eval $dummy5

    for {set j 1} {$j < 9} {incr j} {
	
	set dummy1  [format \
		"set latticeNeighbours_x(%d,%d) 0" $i $j]
	set dummy2  [format \
		"set latticeNeighbours_y(%d,%d) 0" $i $j]
	set dummy3  [format \
		"set latticeNeighbours_z(%d,%d) 0" $i $j]
	set dummy4  [format \
		"set latticeNeighbours_cell(%d,%d) 1" $i $j]

	eval $dummy1
	eval $dummy2
	eval $dummy3
	eval $dummy4
	

    }
}

set latticeNeighbours_number(1) 2

set latticeNeighbours_x(1,1) 1
set latticeNeighbours_y(1,1) 0
set latticeNeighbours_z(1,1) 0
set latticeNeighbours_cell(1,1) 1

set latticeNeighbours_x(1,2) -1
set latticeNeighbours_y(1,2) 0
set latticeNeighbours_z(1,2) 0
set latticeNeighbours_cell(1,2) 1

# Hamiltonian terms 

set current_bond 1
set current_site 1
set current_term 13

# do loop over all lattice neighbours.

for {set b 1} {$b < 3} {incr b} {
    for {set i 1} {$i < 7} {incr i} {
	for {set j 1} {$j < 9} {incr j} {
	    for {set k 1} {$k < 15} {incr k} {
		
		set dummy1  [format \
			"set H_k_to_m_number(%d,%d,%d) 0"\
			$b $i $k]
		set dummy2  [format \
			"set H_m_to_k_number(%d,%d,%d) 0"\
			$b $i $k]
		set dummy3  [format \
			"set H_k_to_m_x(%d,%d,%d,%d) 0" \
			$b $i $j $k]
		set dummy4  [format \
			"set H_k_to_m_y(%d,%d,%d,%d) 0" \
			$b $i $j $k]
		set dummy5  [format \
			"set H_k_to_m_z(%d,%d,%d,%d) 0" \
			$b $i $j $k]
		set dummy6  [format \
			"set H_k_to_m_cell(%d,%d,%d,%d) 0" \
			$b $i $j $k]
		set dummy7  [format \
			"set H_m_to_k_x(%d,%d,%d,%d) 0" \
			$b $i $j $k]
		set dummy8  [format \
			"set H_m_to_k_y(%d,%d,%d,%d) 0" \
			$b $i $j $k]
		set dummy9  [format \
			"set H_m_to_k_z(%d,%d,%d,%d) 0" \
			$b $i $j $k]
		set dummy10 [format \
			"set H_m_to_k_cell(%d,%d,%d,%d) 0" \
			$b $i $j $k]
		set dummy11 [format \
			"set H_coefficient(%d,%d,%d,%d) 0.0" \
			$b $i $j $k]

		eval $dummy1
		eval $dummy2
		eval $dummy3
		eval $dummy4
		eval $dummy5
		eval $dummy6
		eval $dummy7
		eval $dummy8
		eval $dummy9
		eval $dummy10
		eval $dummy11
	    }
	}
    }
}

set H_coefficient(1,1,1,11) -1.0
set H_coefficient(1,1,1,13) -1.0

set H_coefficient(2,1,1,1) -2.0
set H_coefficient(2,1,2,1) -2.0

set H_k_to_m_number(2,1,1) 2
set H_k_to_m_x(2,1,1,1) 1 
set H_k_to_m_y(2,1,1,1) 0 
set H_k_to_m_z(2,1,1,1) 0 
set H_k_to_m_cell(2,1,1,1) 1 
set H_k_to_m_x(2,1,2,1) -1 
set H_k_to_m_y(2,1,2,1) 0 
set H_k_to_m_z(2,1,2,1) 0 
set H_k_to_m_cell(2,1,2,1) 1 

set H_m_to_k_number(2,1,1) 2
set H_m_to_k_x(2,1,1,1) 1 
set H_m_to_k_y(2,1,1,1) 0 
set H_m_to_k_z(2,1,1,1) 0 
set H_m_to_k_cell(2,1,1,1) 1 
set H_m_to_k_x(2,1,2,1) -1 
set H_m_to_k_y(2,1,2,1) 0 
set H_m_to_k_z(2,1,2,1) 0 
set H_m_to_k_cell(2,1,2,1) 1 

# now set initial symmetry operations

set symmetry_number 2
set current_symmetry 1

for {set i 1} {$i < 101} {incr i} {
    for {set j 1} {$j < 4} {incr j} {
	for {set k 1} {$k < 4} {incr k} {
	    
	    if { $j == $k } {
		set dummy1  [format \
			"set LatticeSymmetries_R(%d,%d,%d) 1.0"\
			$i $j $k]
	    } else {
		set dummy1  [format \
			"set LatticeSymmetries_R(%d,%d,%d) 0.0"\
			$i $j $k]
	    }
	    eval $dummy1
	}
    }

    set dummy2  [format \
	    "set LatticeSymmetries_x(%d) 0.0" $i ]
    set dummy3  [format \
	    "set LatticeSymmetries_y(%d) 0.0" $i ]
    set dummy4  [format \
	    "set LatticeSymmetries_z(%d) 0.0" $i ]
    
    eval $dummy2
    eval $dummy3
    eval $dummy4
}

set  LatticeSymmetries_R(2,1,1) -1.0


# Firstly a line saying what this TCL/TK script is.

label .l1 -text "Edit CCM Script" -height 1 -foreground blue -font $Font1
pack .l1 -anchor n -pady 3 -side top 

frame .scriptname -bd 3 
pack .scriptname -anchor n -pady 3 -side top 
label .scriptname.l1 -text "Script Name : "  -height 1 \
	-foreground red -font $Font1
entry .scriptname.e1 -relief sunken -width 20 -textvariable script 
grid config .scriptname.l1 -column 0 -row 0 -sticky w -pady 2 -padx 2 -pady 2
grid config .scriptname.e1 -column 1 -row 0 -sticky w -pady 2 -padx 2 -pady 2

# Now print the copyright message 

label .l3 -text "@COPYRIGHT DAMIAN FARNELL 2002" \
     -height 1 -foreground blue -font $Font2

# create menu bar which allows the user to exit, load, and save:

frame .exit_load_save_refresh -bd 3 
pack .exit_load_save_refresh -side top

button .exit_load_save_refresh.b1 -text "Exit" -font $Font4 \
	-height 1 -width 23 -command { exit }

button .exit_load_save_refresh.b2 -text "Load" -font $Font4 \
	-height 1 -width 23 -command { 

    load_procedure

}

button .exit_load_save_refresh.b3 -text "Save Script" -font $Font4 -height 1 \
	-width 23 -command { 

    save_procedure

}

button .exit_load_save_refresh.b4 -text "Refresh" -font $Font4 \
	-height 1 -width 23 -command { 
    refresh_panel 
    refresh_hamiltonian1
    refresh_hamiltonian2
    refresh_symmetry
}

pack .exit_load_save_refresh.b1 .exit_load_save_refresh.b2 \
	.exit_load_save_refresh.b3 .exit_load_save_refresh.b4 \
	-side left -padx 2 -pady 2

# now the top-level parameters 

frame .parameters -bd 3  
pack .parameters -side top -padx 5 -pady 5 -fill x

label .parameters.l1 -font $Font5 -foreground red \
	-text "Parameters:"
label .parameters.l2 -font $Font6 -text "Work Directory:"
entry .parameters.e2 -relief sunken -width 10 -textvariable tempPath 
label .parameters.l3 -font $Font6 -text "Run Name:"
entry .parameters.e3 -relief sunken -width 10 -textvariable fname 
label .parameters.l4 -font $Font6 -text "Output Level:"
entry .parameters.e4 -relief sunken -width 10 -textvariable output 
label .parameters.l5 -font $Font6 -text "Dimension (1-3):"
entry .parameters.e5 -relief sunken -width 3 -textvariable dimension 

label .parameters.l6 -font $Font6 -text "Spin (0.5,1.0,...):"
entry .parameters.e6 -relief sunken -width 4 -textvariable spin 
#label .parameters.l7 -font $Font6 -text "Bounding (>2m):"
#entry .parameters.e7 -relief sunken -width 10 -textvariable bounding 
label .parameters.l8 -font $Font6 -text "SUBn-m n=:"
entry .parameters.e8 -relief sunken -width 10 -textvariable n 
label .parameters.l9 -font $Font6 -text "SUBn-m m=:"
entry .parameters.e9 -relief sunken -width 10 -textvariable m 
#label .parameters.l10 -font $Font6 -text "H_1 or H_2?"
#entry .parameters.e10 -relief sunken -width 3 -textvariable bonds 
#label .parameters.lbonds -font $Font6 -text "2"

label .parameters.l11 -font $Font5 -foreground red -text \
	"Solve: " 

label .parameters.l12 -font $Font6 -text "Minimum x:"
entry .parameters.e12 -relief sunken -width 8 -textvariable  minimum 
label .parameters.l13 -font $Font6 -text "Maximum x:"
entry .parameters.e13 -relief sunken -width 8 -textvariable  maximum
label .parameters.l14 -font $Font6 -text "Increment x:"
entry .parameters.e14 -relief sunken -width 8 -textvariable  increment
label .parameters.l15 -font $Font6 -text "Minimum y:"
entry .parameters.e15 -relief sunken -width 8 -textvariable  minimumy 
label .parameters.l16 -font $Font6 -text "Maximum y:"
entry .parameters.e16 -relief sunken -width 8 -textvariable  maximumy

menubutton .parameters.restrict -text "Restriction:" -background blue \
	-foreground white  -font $Font3 -padx 1m -relief groove\
	-pady 2 -menu .parameters.restrict.menu

set restriction 1

menu .parameters.restrict.menu -background blue -foreground white

.parameters.restrict.menu add radiobutton -label "No restriction" \
	-font $Font6 -variable  restriction -value 1
.parameters.restrict.menu add radiobutton -label "Even # Spin Flips" \
	-font $Font6 -variable  restriction -value 2
.parameters.restrict.menu add radiobutton -label "User Defined" \
	-font $Font6 -variable  restriction -value 3

set solutionStrategy 1

menubutton .parameters.solution -text "Sol. Strategy:" -background blue \
	-foreground white  -font $Font3 -padx 1m -relief groove\
	-pady 2 -menu .parameters.solution.menu

menu .parameters.solution.menu -background blue -foreground white

.parameters.solution.menu add radiobutton -label "Newton-Raphson" \
	-font $Font6 -variable  solutionStrategy -value 1
.parameters.solution.menu add radiobutton -label "Direct Iteration" \
	-font $Font6 -variable  solutionStrategy -value 2

grid config .parameters.l1 -column 0 -row 0 -sticky w -pady 2 -padx 2 -pady 2

grid config .parameters.l2 -column 1 -row 0 -sticky e -pady 2 -padx 2
grid config .parameters.e2 -column 2 -row 0 -sticky w -pady 2 -padx 2
grid config .parameters.l3 -column 3 -row 0 -sticky e -pady 2 -padx 2
grid config .parameters.e3 -column 4 -row 0 -sticky w -pady 2 -padx 2
grid config .parameters.l4 -column 5 -row 0 -sticky e -pady 2 -padx 2
grid config .parameters.e4 -column 6 -row 0 -sticky w -pady 2 -padx 2
grid config .parameters.l5 -column 7 -row 0 -sticky e -pady 2 -padx 2
grid config .parameters.e5 -column 8 -row 0 -sticky w -pady 2 -padx 2
grid config .parameters.l6 -column 9 -row 0 -sticky e -pady 2 -padx 2
grid config .parameters.e6 -column 10 -row 0 -sticky w -pady 2 -padx 2

#grid config .parameters.l7 -column 5 -row 1 -sticky e -pady 2
#grid config .parameters.e7 -column 6 -row 1 -sticky w -pady 2 -padx 2
grid config .parameters.l8 -column 1 -row 1 -sticky e -pady 2 -padx 2
grid config .parameters.e8 -column 2 -row 1 -sticky w -pady 2 -padx 2
grid config .parameters.l9 -column 3 -row 1 -sticky e -pady 2 -padx 2
grid config .parameters.e9 -column 4 -row 1 -sticky w -pady 2 -padx 2

#grid config .parameters.l10 -column 7 -row 1 -sticky e -pady 2 -padx 2
#grid config .parameters.lbonds -column 8 -row 1 -sticky w -pady 2 -padx 2

grid config .parameters.l11 -column 0 -row 2 -sticky w -pady 10 -padx 2
grid config .parameters.l12 -column 1 -row 2 -sticky e -pady 10 -padx 2
grid config .parameters.e12 -column 2 -row 2 -sticky w -pady 10 -padx 2
grid config .parameters.l13 -column 3 -row 2 -sticky e -pady 10 -padx 2
grid config .parameters.e13 -column 4 -row 2 -sticky w -pady 10 -padx 2
grid config .parameters.l14 -column 5 -row 2 -sticky e -pady 10 -padx 2
grid config .parameters.e14 -column 6 -row 2 -sticky w -pady 10 -padx 2
grid config .parameters.l15 -column 7 -row 2 -sticky e -pady 10 -padx 2
grid config .parameters.e15 -column 8 -row 2 -sticky w -pady 10 -padx 2
grid config .parameters.l16 -column 9 -row 2 -sticky e -pady 10 -padx 2
grid config .parameters.e16 -column 10 -row 2 -sticky w -pady 10 -padx 2

grid config  .parameters.restrict -column 9 -row 1 -sticky w -pady 10 -padx 2
grid config  .parameters.solution -column 7 -row 1 -sticky e -pady 2 -padx 2

# now bravais lattice

frame .bravais -bd 3  
pack .bravais -side top -padx 5 -pady 5 -fill x

label .bravais.l0 -font $Font5 -foreground red -text \
	"Bravais Lattice Vectors: " 
label .bravais.l1 -font $Font6 -text " a = ("
entry .bravais.e1 -relief sunken -width 4 -textvariable  bravaisLattice_a(1) 
label .bravais.l2 -font $Font6 -text ","
entry .bravais.e2 -relief sunken -width 4 -textvariable  bravaisLattice_a(2)
label .bravais.l3 -font $Font6 -text ","
entry .bravais.e3 -relief sunken -width 4 -textvariable  bravaisLattice_a(3)
label .bravais.l4 -font $Font6 -text "), b = ("
entry .bravais.e4 -relief sunken -width 4 -textvariable  bravaisLattice_b(1)
label .bravais.l5 -font $Font6 -text ","
entry .bravais.e5 -relief sunken -width 4 -textvariable  bravaisLattice_b(2)
label .bravais.l6 -font $Font6 -text ","
entry .bravais.e6 -relief sunken -width 4 -textvariable  bravaisLattice_b(3)
label .bravais.l7 -font $Font6 -text "), c = ("
entry .bravais.e7 -relief sunken -width 4 -textvariable  bravaisLattice_c(1)
label .bravais.l8 -font $Font6 -text ","
entry .bravais.e8 -relief sunken -width 4 -textvariable  bravaisLattice_c(2)
label .bravais.l9 -font $Font6 -text ","
entry .bravais.e9 -relief sunken -width 4 -textvariable  bravaisLattice_c(3)
label .bravais.l10 -font $Font6 -text ")                  "

grid config .bravais.l0 -column 0 -row 0 -sticky e -pady 2 -padx 2 
grid config .bravais.l1 -column 1 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.e1 -column 2 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.l2 -column 3 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.e2 -column 4 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.l3 -column 5 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.e3 -column 6 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.l4 -column 7 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.e4 -column 8 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.l5 -column 9 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.e5 -column 10 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.l6 -column 11 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.e6 -column 12 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.l7 -column 13 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.e7 -column 14 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.l8 -column 15 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.e8 -column 16 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.l9 -column 17 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.e9 -column 18 -row 0 -sticky e -pady 2 -padx 2
grid config .bravais.l10 -column 19 -row 0 -sticky e -pady 2 -padx 2

frame .unitCell -bd 3  
pack .unitCell -side top -padx 5 -pady 5 

menubutton .unitCell.ucNum -text "# Sites Unit Cell:"  -background blue  \
	-foreground white  -font $Font3 -padx 1m -relief groove \
	-pady 2 -menu .unitCell.ucNum.menu  

menu .unitCell.ucNum.menu  -background blue  -foreground white
.unitCell.ucNum.menu add radiobutton -label "#UC=1" -font $Font6 \
	-variable  unitCell_number -value 1
.unitCell.ucNum.menu add radiobutton -label "#UC=2" -font $Font6 \
	-variable  unitCell_number -value 2
.unitCell.ucNum.menu add radiobutton -label "#UC=3" -font $Font6 \
	-variable  unitCell_number -value 3
.unitCell.ucNum.menu add radiobutton -label "#UC=4" -font $Font6 \
	-variable  unitCell_number -value 4
.unitCell.ucNum.menu add radiobutton -label "#UC=5" -font $Font6 \
	-variable  unitCell_number -value 5
.unitCell.ucNum.menu add radiobutton -label "#UC=6" -font $Font6 \
	-variable  unitCell_number -value 6

label .unitCell.l1 -font $Font6 -text "UC#1 x="
entry .unitCell.e1 -relief sunken -width 4 -textvariable unitCell_x(1) 
label .unitCell.l2 -font $Font6 -text "y="
entry .unitCell.e2 -relief sunken -width 4 -textvariable unitCell_y(1)
label .unitCell.l3 -font $Font6 -text "z="
entry .unitCell.e3 -relief sunken -width 4 -textvariable unitCell_z(1) 
label .unitCell.l4 -font $Font6 -text "s="
entry .unitCell.e4 -relief sunken -width 4 -textvariable unitCell_s(1) 

grid config .unitCell.ucNum -column 0 -row 0 -sticky e -pady 2 -padx 2 
grid config .unitCell.l1 -column 1 -row 0 -sticky e -pady 2 -padx 2 
grid config .unitCell.e1 -column 2 -row 0 -sticky w -pady 2 -padx 2 
grid config .unitCell.l2 -column 3 -row 0 -sticky e -pady 2 -padx 2 
grid config .unitCell.e2 -column 4 -row 0 -sticky w -pady 2 -padx 2
grid config .unitCell.l3 -column 5 -row 0 -sticky e -pady 2 -padx 2 
grid config .unitCell.e3 -column 6 -row 0 -sticky w -pady 2 -padx 2 
grid config .unitCell.l4 -column 7 -row 0 -sticky e -pady 2 -padx 2 
grid config .unitCell.e4 -column 8 -row 0 -sticky w -pady 2 -padx 2 

frame .neighbours -bd 3  
pack .neighbours -side top -padx 5 -pady 5

menubutton .neighbours.nnNum1 -text "UC#1: #NNs"  -background blue  \
	-foreground white  -font $Font3 -padx 1m -relief groove\
	-pady 2 -menu .neighbours.nnNum1.menu

menu .neighbours.nnNum1.menu  -background blue  -foreground white

.neighbours.nnNum1.menu add radiobutton -label "#nn=1" -font $Font6 \
	-variable  latticeNeighbours_number(1) -value 1
.neighbours.nnNum1.menu add radiobutton -label "#nn=2" -font $Font6 \
	-variable  latticeNeighbours_number(1) -value 2
.neighbours.nnNum1.menu add radiobutton -label "#nn=3" -font $Font6 \
	-variable  latticeNeighbours_number(1) -value 3
.neighbours.nnNum1.menu add radiobutton -label "#nn=4" -font $Font6 \
	-variable  latticeNeighbours_number(1) -value 4
.neighbours.nnNum1.menu add radiobutton -label "#nn=5" -font $Font6 \
	-variable  latticeNeighbours_number(1) -value 5
.neighbours.nnNum1.menu add radiobutton -label "#nn=6" -font $Font6 \
	-variable  latticeNeighbours_number(1) -value 6
.neighbours.nnNum1.menu add radiobutton -label "#nn=7" -font $Font6 \
	-variable  latticeNeighbours_number(1) -value 7
.neighbours.nnNum1.menu add radiobutton -label "#nn=8" -font $Font6 \
	-variable  latticeNeighbours_number(1) -value 8

label .neighbours.l11     -font $Font6 -text "1 "
entry .neighbours.e11x    -relief sunken -width 2 -textvariable latticeNeighbours_x(1,1)
entry .neighbours.e11y    -relief sunken -width 2 -textvariable latticeNeighbours_y(1,1)
entry .neighbours.e11z    -relief sunken -width 2 -textvariable latticeNeighbours_z(1,1)
entry .neighbours.e11cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(1,1)

label .neighbours.l12     -font $Font6 -text "2 "
entry .neighbours.e12x    -relief sunken -width 2 -textvariable latticeNeighbours_x(1,2)
entry .neighbours.e12y    -relief sunken -width 2 -textvariable latticeNeighbours_y(1,2)
entry .neighbours.e12z    -relief sunken -width 2 -textvariable latticeNeighbours_z(1,2)
entry .neighbours.e12cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(1,2)

grid config .neighbours.nnNum1         -column 0 -row 0 -sticky e -pady 2 -padx 2
grid config .neighbours.l11            -column 1 -row 0 -sticky e -pady 2 -padx 2
grid config .neighbours.e11x           -column 2 -row 0 -sticky e -pady 2 -padx 2
grid config .neighbours.e11y           -column 3 -row 0 -sticky e -pady 2 -padx 2
grid config .neighbours.e11z           -column 4 -row 0 -sticky e -pady 2 -padx 2
grid config .neighbours.e11cell        -column 5 -row 0 -sticky e -pady 2 -padx 2

grid config .neighbours.l12            -column 6  -row 0 -sticky e -pady 2 -padx 2
grid config .neighbours.e12x           -column 7  -row 0 -sticky e -pady 2 -padx 2
grid config .neighbours.e12y           -column 8 -row 0 -sticky e -pady 2 -padx 2
grid config .neighbours.e12z           -column 9 -row 0 -sticky e -pady 2 -padx 2
grid config .neighbours.e12cell        -column 10 -row 0 -sticky e -pady 2 -padx 2

# NOW DO HAMILTONIAN

frame .hamiltonian -bd 3  
pack  .hamiltonian -side top -padx 5 -pady 5

label .hamiltonian.l1 -font $Font5 -foreground red \
	-text "Parameters for Hamiltonian:"

menubutton .hamiltonian.uc -text "Site in UC:"  -background blue  \
	-foreground white  -font $Font3 -padx 1m -relief groove\
	-pady 2 -menu .hamiltonian.uc.menu  

menu .hamiltonian.uc.menu  -background blue  -foreground white
.hamiltonian.uc.menu add radiobutton -label "#UC=1" -font $Font6 \
	-variable  current_site -value 1
.hamiltonian.uc.menu add radiobutton -label "#UC=2" -font $Font6 \
	-variable  current_site -value 2
.hamiltonian.uc.menu add radiobutton -label "#UC=3" -font $Font6 \
	-variable  current_site -value 3
.hamiltonian.uc.menu add radiobutton -label "#UC=4" -font $Font6 \
	-variable  current_site -value 4
.hamiltonian.uc.menu add radiobutton -label "#UC=5" -font $Font6 \
	-variable  current_site -value 5
.hamiltonian.uc.menu add radiobutton -label "#UC=6" -font $Font6 \
	-variable  current_site -value 6

menubutton .hamiltonian.term -text "Term in Hamiltonian:"  -background blue  \
	-foreground white  -font $Font3 -padx 1m -relief groove\
	-pady 2 -menu .hamiltonian.term.menu  

menu .hamiltonian.term.menu  -background blue  -foreground white
.hamiltonian.term.menu add radiobutton -label "s^z s^z" -font $Font6 \
	-variable  current_term -value 1
.hamiltonian.term.menu add radiobutton -label "s^z s^+" -font $Font6 \
	-variable  current_term -value 2
.hamiltonian.term.menu add radiobutton -label "s^z s^-" -font $Font6 \
	-variable  current_term -value 3
.hamiltonian.term.menu add radiobutton -label "s^+ s^z" -font $Font6 \
	-variable  current_term -value 4
.hamiltonian.term.menu add radiobutton -label "s^- s^z" -font $Font6 \
	-variable  current_term -value 5
.hamiltonian.term.menu add radiobutton -label "s^+ s^-" -font $Font6 \
	-variable  current_term -value 6
.hamiltonian.term.menu add radiobutton -label "s^- s^+" -font $Font6 \
	-variable  current_term -value 7
.hamiltonian.term.menu add radiobutton -label "s^+ s^+" -font $Font6 \
	-variable  current_term -value 8
.hamiltonian.term.menu add radiobutton -label "s^- s^-" -font $Font6 \
	-variable  current_term -value 9
.hamiltonian.term.menu add radiobutton -label "s^z" -font $Font6 \
	-variable  current_term -value 10
.hamiltonian.term.menu add radiobutton -label "s^-" -font $Font6 \
	-variable  current_term -value 11
.hamiltonian.term.menu add radiobutton -label "(s^z)^2" -font $Font6 \
	-variable  current_term -value 12
.hamiltonian.term.menu add radiobutton -label "s^+" -font $Font6 \
	-variable  current_term -value 13

menubutton .hamiltonian.bond -text "H_1 or H_2?"  -background blue  \
	-foreground white  -font $Font3 -padx 1m -relief groove\
	-pady 2 -menu .hamiltonian.bond.menu  

menu .hamiltonian.bond.menu  -background blue  -foreground white
.hamiltonian.bond.menu add radiobutton -label "H_1" -font $Font6 \
	-variable  current_bond -value 1
.hamiltonian.bond.menu add radiobutton -label "H_2" -font $Font6 \
	-variable  current_bond -value 2

menubutton .hamiltonian.directional -text "Directional?"  -background blue  \
	-foreground white  -font $Font3 -padx 1m -relief groove\
	-pady 2 -menu .hamiltonian.directional.menu

menu .hamiltonian.directional.menu  -background blue  -foreground white
.hamiltonian.directional.menu add radiobutton -label "No" -font $Font6 \
	-variable  directional -value 0
.hamiltonian.directional.menu add radiobutton -label "Yes" -font $Font6 \
	-variable  directional -value 1

label .hamiltonian.l2 -font $Font5 -foreground red \
	-text "                        "

grid config .hamiltonian.l1             -column 0  -row 0 -sticky e -pady 2 -padx 2
grid config .hamiltonian.uc             -column 1  -row 0 -sticky w -pady 2 -padx 2
grid config .hamiltonian.term           -column 2  -row 0 -sticky w -pady 2 -padx 2
grid config .hamiltonian.bond           -column 3  -row 0 -sticky w -pady 2 -padx 2
grid config .hamiltonian.l2             -column 5  -row 0 -sticky w -pady 2 -padx 2
grid config .hamiltonian.directional    -column 4  -row 0 -sticky w -pady 2 -padx 2
	
frame .hamiltonian2 -bd 3  
pack  .hamiltonian2 -side top -padx 5 -pady 5

if {$current_term == 1} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^z s^z " \
	    $current_bond $current_site]
} elseif {$current_term == 2} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^z s^+ " \
	    $current_bond $current_site ]
} elseif {$current_term == 3} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^z s^- " \
	    $current_bond $current_site ]
} elseif {$current_term == 4} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^+ s^z " \
	    $current_bond $current_site ]
} elseif {$current_term == 5} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^- s^z " \
	    $current_bond $current_site ]
} elseif {$current_term == 6} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^+ s^- " \
	    $current_bond $current_site ]
} elseif {$current_term == 7} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^- s^+ " \
	    $current_bond $current_site ]
} elseif {$current_term == 8} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^+ s^+ " \
	    $current_bond $current_site ]
} elseif {$current_term == 9} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^- s^- " \
	    $current_bond $current_site ]
} elseif {$current_term == 10} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^z " \
	    $current_bond $current_site ]
} elseif {$current_term == 11} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^- " \
	    $current_bond $current_site ]
} elseif {$current_term == 12} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d Term=(s^z)^2 " \
	    $current_bond $current_site ]
} elseif {$current_term == 13} {
    label .hamiltonian2.l0 -font $Font5 -foreground red \
	    -text [format "H%d Site=%d s^+ " \
	    $current_bond $current_site ]
} 

menubutton .hamiltonian2.neigh -text "#Ham. Neighs."  -background blue  \
	-foreground white  -font $Font3 -padx 1m -relief groove\
	-pady 2 -menu .hamiltonian2.neigh.menu  

menu .hamiltonian2.neigh.menu  -background blue  -foreground white
.hamiltonian2.neigh.menu add radiobutton -label "#=0" -font $Font6 \
	-variable  [format \
	"H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 0
.hamiltonian2.neigh.menu add radiobutton -label "#=1" -font $Font6 \
	-variable  [format \
	"H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 1
.hamiltonian2.neigh.menu add radiobutton -label "#=2" -font $Font6 \
	-variable  [format \
	"H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 2
.hamiltonian2.neigh.menu add radiobutton -label "#=3" -font $Font6 \
	-variable  [format \
	"H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 3
.hamiltonian2.neigh.menu add radiobutton -label "#=4" -font $Font6 \
	-variable  [format \
	"H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 4
.hamiltonian2.neigh.menu add radiobutton -label "#=5" -font $Font6 \
	-variable  [format \
	"H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 5
.hamiltonian2.neigh.menu add radiobutton -label "#=6" -font $Font6 \
	-variable  [format \
	"H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 6
.hamiltonian2.neigh.menu add radiobutton -label "#=7" -font $Font6 \
	-variable  [format \
	"H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 7
.hamiltonian2.neigh.menu add radiobutton -label "#=8" -font $Font6 \
	-variable  [format \
	"H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 8

if { $directional == 1 && $current_term <= 9} {
    label .hamiltonian2.lnote -font $Font5 -foreground red \
	    -text "Directional ---> " 
} else {
    label .hamiltonian2.lnote -font $Font5 -foreground red \
	    -text " " 
}

set one 1
set two 2
set three 3

label .hamiltonian2.coefflabel -font $Font6 -text "  Coeff"
entry .hamiltonian2.coeffentry -relief sunken -width 5 -textvariable [format \
	"H_coefficient(%d,%d,%d,%d)" $current_bond $current_site $one \
	$current_term]

grid config .hamiltonian2.l0            -column 0 -row 0 -sticky e -pady 2 -padx 2
grid config .hamiltonian2.neigh         -column 1 -row 0 -sticky e -pady 2 -padx 2
grid config .hamiltonian2.coefflabel    -column 2 -row 0 -sticky e -pady 2 -padx 2
grid config .hamiltonian2.coeffentry    -column 3 -row 0 -sticky e -pady 2 -padx 2
grid config .hamiltonian2.lnote         -column 0 -row 1 -sticky w -pady 2 -padx 2


frame .symmetry -bd 3  
pack  .symmetry -side top -padx 5 -pady 5

label .symmetry.l1 -font $Font5 -foreground red \
	-text "Define Lattice Symmetries:"
label .symmetry.l2 -font $Font6 -text "Total Number Symmetries:"
entry .symmetry.e1 -relief sunken -width 2 -textvariable symmetry_number 
label .symmetry.l3 -font $Font6 -text "This Symmetry Operation:"
entry .symmetry.e2 -relief sunken -width 2 -textvariable current_symmetry

label .symmetry.l4 -font $Font6 -text "    R= "
entry .symmetry.eR11    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $one $one]
entry .symmetry.eR12    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $one $two]
entry .symmetry.eR13    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $one $three]
entry .symmetry.eR21    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $two $one]
entry .symmetry.eR22    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $two $two]
entry .symmetry.eR23    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $two $three]
entry .symmetry.eR31    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $three $one]
entry .symmetry.eR32    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $three $two]
entry .symmetry.eR33    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $three $three]

label .symmetry.l5 -font $Font6 -text "    T= "
entry .symmetry.ex    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_x(%d)" $current_symmetry]
entry .symmetry.ey    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_y(%d)" $current_symmetry]
entry .symmetry.ez    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_z(%d)" $current_symmetry]

grid config .symmetry.l1   -column 0 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.l2   -column 1 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.e1   -column 2 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.l3   -column 3 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.e2   -column 4 -row 0 -sticky e -pady 2 -padx 2

grid config .symmetry.l4   -column 5 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.eR11 -column 6 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.eR12 -column 7 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.eR13 -column 8 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.eR21 -column 6 -row 1 -sticky e -pady 2 -padx 2
grid config .symmetry.eR22 -column 7 -row 1 -sticky e -pady 2 -padx 2
grid config .symmetry.eR23 -column 8 -row 1 -sticky e -pady 2 -padx 2
grid config .symmetry.eR31 -column 6 -row 2 -sticky e -pady 2 -padx 2
grid config .symmetry.eR32 -column 7 -row 2 -sticky e -pady 2 -padx 2
grid config .symmetry.eR33 -column 8 -row 2 -sticky e -pady 2 -padx 2

grid config .symmetry.l5   -column 9 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.ex   -column 10 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.ey   -column 11 -row 0 -sticky e -pady 2 -padx 2
grid config .symmetry.ez   -column 12 -row 0 -sticky e -pady 2 -padx 2

pack .l3 -anchor n -pady 2 -side top 

bind all <Key-Return> {
    refresh_panel 
    refresh_hamiltonian1
    refresh_hamiltonian2
    refresh_symmetry
}


proc refresh_symmetry { } {

    
#   define global variables first.

    global Font1 
    global Font2 
    global Font3 
    global Font4 
    global Font5 
    global Font6 
    global Font7 

    global symmetry_number 
    global current_symmetry

    global LatticeSymmetries_R
    global LatticeSymmetries_x
    global LatticeSymmetries_y
    global LatticeSymmetries_z

    set one 1
    set two 2
    set three 3
    
    destroy .symmetry
    destroy .l3  
    
    frame .symmetry -bd 3  
    pack  .symmetry -side top -padx 5 -pady 5
    
    label .symmetry.l1 -font $Font5 -foreground red \
	    -text "Define Lattice Symmetries:"
    label .symmetry.l2 -font $Font6 -text "Total Number Symmetries:"
    entry .symmetry.e1 -relief sunken -width 2 -textvariable symmetry_number 
    label .symmetry.l3 -font $Font6 -text "This Symmetry Operation:"
    entry .symmetry.e2 -relief sunken -width 2 -textvariable current_symmetry
    
    label .symmetry.l4 -font $Font6 -text "    R= "
    entry .symmetry.eR11    -relief sunken -width 4 -textvariable [format \
	    "LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $one $one]
    entry .symmetry.eR12    -relief sunken -width 4 -textvariable [format \
	    "LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $one $two]
    entry .symmetry.eR13    -relief sunken -width 4 -textvariable [format \
	    "LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $one $three]
    entry .symmetry.eR21    -relief sunken -width 4 -textvariable [format \
	    "LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $two $one]
    entry .symmetry.eR22    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $two $two]
    entry .symmetry.eR23    -relief sunken -width 4 -textvariable [format \
	    "LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $two $three]
    entry .symmetry.eR31    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $three $one]
    entry .symmetry.eR32    -relief sunken -width 4 -textvariable [format \
	    "LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $three $two]
    entry .symmetry.eR33    -relief sunken -width 4 -textvariable [format \
	    "LatticeSymmetries_R(%d,%d,%d)" $current_symmetry $three $three]
    
    label .symmetry.l5 -font $Font6 -text "    T= "
    entry .symmetry.ex    -relief sunken -width 4 -textvariable [format \
	    "LatticeSymmetries_x(%d)" $current_symmetry]
    entry .symmetry.ey    -relief sunken -width 4 -textvariable [format \
	"LatticeSymmetries_y(%d)" $current_symmetry]
    entry .symmetry.ez    -relief sunken -width 4 -textvariable [format \
	    "LatticeSymmetries_z(%d)" $current_symmetry]
    
    grid config .symmetry.l1   -column 0 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.l2   -column 1 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.e1   -column 2 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.l3   -column 3 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.e2   -column 4 -row 0 -sticky e -pady 2 -padx 2
    
    grid config .symmetry.l4   -column 5 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.eR11 -column 6 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.eR12 -column 7 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.eR13 -column 8 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.eR21 -column 6 -row 1 -sticky e -pady 2 -padx 2
    grid config .symmetry.eR22 -column 7 -row 1 -sticky e -pady 2 -padx 2
    grid config .symmetry.eR23 -column 8 -row 1 -sticky e -pady 2 -padx 2
    grid config .symmetry.eR31 -column 6 -row 2 -sticky e -pady 2 -padx 2
    grid config .symmetry.eR32 -column 7 -row 2 -sticky e -pady 2 -padx 2
    grid config .symmetry.eR33 -column 8 -row 2 -sticky e -pady 2 -padx 2
    
    grid config .symmetry.l5   -column 9 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.ex   -column 10 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.ey   -column 11 -row 0 -sticky e -pady 2 -padx 2
    grid config .symmetry.ez   -column 12 -row 0 -sticky e -pady 2 -padx 2
    
    
    label .l3 -text "@COPYRIGHT DAMIAN FARNELL 2002" \
     -height 1 -foreground blue -font $Font2
    pack .l3 -anchor n -pady 2 -side top 

    return
}

proc refresh_panel { } {

#   define global variables first.

    global Font1 
    global Font2 
    global Font3 
    global Font4 
    global Font5 
    global Font6 
    global Font7 

    global unitCell_number

    global unitCell_x
    global unitCell_y
    global unitCell_z
    global unitCell_s

    global latticeNeighbours_number
    global latticeNeighbours_x
    global latticeNeighbours_y
    global latticeNeighbours_z
    global latticeNeighbours_cell

#   now refresh the unit cell frame
    
    destroy .unitCell

    frame .unitCell -bd 3  
    pack .unitCell -side top -padx 5 -pady 5
    
    menubutton .unitCell.ucNum -text "# Sites Unit Cell:"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .unitCell.ucNum.menu  
    
    menu .unitCell.ucNum.menu  -background blue  -foreground white
    .unitCell.ucNum.menu add radiobutton -label "#UC=1" -font $Font6 \
	    -variable  unitCell_number -value 1
    .unitCell.ucNum.menu add radiobutton -label "#UC=2" -font $Font6 \
	    -variable  unitCell_number -value 2
    .unitCell.ucNum.menu add radiobutton -label "#UC=3" -font $Font6 \
	    -variable  unitCell_number -value 3
    .unitCell.ucNum.menu add radiobutton -label "#UC=4" -font $Font6 \
	    -variable  unitCell_number -value 4
    .unitCell.ucNum.menu add radiobutton -label "#UC=5" -font $Font6 \
	    -variable  unitCell_number -value 5
    .unitCell.ucNum.menu add radiobutton -label "#UC=6" -font $Font6 \
	    -variable  unitCell_number -value 6
    
    label .unitCell.l1 -font $Font6 -text "UC#1 x="
    entry .unitCell.e1 -relief sunken -width 4 -textvariable unitCell_x(1) 
    label .unitCell.l2 -font $Font6 -text "y="
    entry .unitCell.e2 -relief sunken -width 4 -textvariable unitCell_y(1)
    label .unitCell.l3 -font $Font6 -text "z="
    entry .unitCell.e3 -relief sunken -width 4 -textvariable unitCell_z(1) 
    label .unitCell.l4 -font $Font6 -text "s="
    entry .unitCell.e4 -relief sunken -width 4 -textvariable unitCell_s(1) 
    
    label .unitCell.l5 -font $Font6 -text " UC#2 x="
    entry .unitCell.e5 -relief sunken -width 4 -textvariable unitCell_x(2) 
    label .unitCell.l6 -font $Font6 -text "y="
    entry .unitCell.e6 -relief sunken -width 4 -textvariable unitCell_y(2) 
    label .unitCell.l7 -font $Font6 -text "z="
    entry .unitCell.e7 -relief sunken -width 4 -textvariable unitCell_z(2)  
    label .unitCell.l8 -font $Font6 -text "s="
    entry .unitCell.e8 -relief sunken -width 4 -textvariable unitCell_s(2) 
    
    label .unitCell.l9 -font $Font6 -text " UC#3 x="
    entry .unitCell.e9 -relief sunken -width 4 -textvariable unitCell_x(3) 
    label .unitCell.l10 -font $Font6 -text "y="
    entry .unitCell.e10 -relief sunken -width 4 -textvariable unitCell_y(3) 
    label .unitCell.l11 -font $Font6 -text "z="
    entry .unitCell.e11 -relief sunken -width 4 -textvariable unitCell_z(3)  
    label .unitCell.l12 -font $Font6 -text "s="
    entry .unitCell.e12 -relief sunken -width 4 -textvariable unitCell_s(3) 
    
    label .unitCell.l13 -font $Font6 -text "UC#4 x="
    entry .unitCell.e13 -relief sunken -width 4 -textvariable unitCell_x(4) 
    label .unitCell.l14 -font $Font6 -text "y="
    entry .unitCell.e14 -relief sunken -width 4 -textvariable unitCell_y(4) 
    label .unitCell.l15 -font $Font6 -text "z="
    entry .unitCell.e15 -relief sunken -width 4 -textvariable unitCell_z(4)  
    label .unitCell.l16 -font $Font6 -text "s="
    entry .unitCell.e16 -relief sunken -width 4 -textvariable unitCell_s(4) 

    label .unitCell.l17 -font $Font6 -text " UC#5 x="
    entry .unitCell.e17 -relief sunken -width 4 -textvariable unitCell_x(5) 
    label .unitCell.l18 -font $Font6 -text "y="
    entry .unitCell.e18 -relief sunken -width 4 -textvariable unitCell_y(5) 
    label .unitCell.l19 -font $Font6 -text "z="
    entry .unitCell.e19 -relief sunken -width 4 -textvariable unitCell_z(5)  
    label .unitCell.l20 -font $Font6 -text "s="
    entry .unitCell.e20 -relief sunken -width 4 -textvariable unitCell_s(5) 

    label .unitCell.l21 -font $Font6 -text " UC#6 x="
    entry .unitCell.e21 -relief sunken -width 4 -textvariable unitCell_x(6) 
    label .unitCell.l22 -font $Font6 -text "y="
    entry .unitCell.e22 -relief sunken -width 4 -textvariable unitCell_y(6) 
    label .unitCell.l23 -font $Font6 -text "z="
    entry .unitCell.e23 -relief sunken -width 4 -textvariable unitCell_z(6)  
    label .unitCell.l24 -font $Font6 -text "s="
    entry .unitCell.e24 -relief sunken -width 4 -textvariable unitCell_s(6) 

    if { $unitCell_number >= 1 } then {
	grid config .unitCell.ucNum -column 0 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.l1 -column 1 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e1 -column 2 -row 0 -sticky w -pady 2 -padx 2
	grid config .unitCell.l2 -column 3 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e2 -column 4 -row 0 -sticky w -pady 2 -padx 2
	grid config .unitCell.l3 -column 5 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e3 -column 6 -row 0 -sticky w -pady 2 -padx 2
	grid config .unitCell.l4 -column 7 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e4 -column 8 -row 0 -sticky w -pady 2 -padx 2
    } 
    if { $unitCell_number >= 2 } {
	grid config .unitCell.l5 -column 9 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e5 -column 10 -row 0 -sticky w -pady 2 -padx 2
	grid config .unitCell.l6 -column 11 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e6 -column 12 -row 0 -sticky w -pady 2 -padx 2
	grid config .unitCell.l7 -column 13 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e7 -column 14 -row 0 -sticky w -pady 2 -padx 2
	grid config .unitCell.l8 -column 15 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e8 -column 16 -row 0 -sticky w -pady 2 -padx 2
    } 
    if { $unitCell_number >= 3 } {
	grid config .unitCell.l9 -column 17 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e9 -column 18 -row 0 -sticky w -pady 2 -padx 2
	grid config .unitCell.l10 -column 19 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e10 -column 20 -row 0 -sticky w -pady 2 -padx 2
	grid config .unitCell.l11 -column 21 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e11 -column 22 -row 0 -sticky w -pady 2 -padx 2
	grid config .unitCell.l12 -column 23 -row 0 -sticky e -pady 2 -padx 2
	grid config .unitCell.e12 -column 24 -row 0 -sticky w -pady 2 -padx 2
    } 
    if { $unitCell_number >= 4 } {
	grid config .unitCell.l13 -column 1 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e13 -column 2 -row 1 -sticky w -pady 2 -padx 2
	grid config .unitCell.l14 -column 3 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e14 -column 4 -row 1 -sticky w -pady 2 -padx 2
	grid config .unitCell.l15 -column 5 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e15 -column 6 -row 1 -sticky w -pady 2 -padx 2
	grid config .unitCell.l16 -column 7 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e16 -column 8 -row 1 -sticky w -pady 2 -padx 2
    }
    if { $unitCell_number >= 5 } {
	grid config .unitCell.l17 -column 9 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e17 -column 10 -row 1 -sticky w -pady 2 -padx 2
	grid config .unitCell.l18 -column 11 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e18 -column 12 -row 1 -sticky w -pady 2 -padx 2
	grid config .unitCell.l19 -column 13 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e19 -column 14 -row 1 -sticky w -pady 2 -padx 2
	grid config .unitCell.l20 -column 15 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e20 -column 16 -row 1 -sticky w -pady 2 -padx 2
    }
    if { $unitCell_number >= 6 } {
	grid config .unitCell.l21 -column 17 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e21 -column 18 -row 1 -sticky w -pady 2 -padx 2
	grid config .unitCell.l22 -column 19 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e22 -column 20 -row 1 -sticky w -pady 2 -padx 2
	grid config .unitCell.l23 -column 21 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e23 -column 22 -row 1 -sticky w -pady 2 -padx 2
	grid config .unitCell.l24 -column 23 -row 1 -sticky e -pady 2 -padx 2
	grid config .unitCell.e24 -column 24 -row 1 -sticky w -pady 2 -padx 2
    }
    
#   now refresh the lattice neighbours frame
    
    destroy .neighbours 

    frame .neighbours -bd 3  
    pack  .neighbours -side top -padx 5 -pady 5
    
    menubutton .neighbours.nnNum1 -text "UC#1: #NNs"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .neighbours.nnNum1.menu
    
    menu .neighbours.nnNum1.menu  -background blue  -foreground white
    
    .neighbours.nnNum1.menu add radiobutton -label "#nn=1" -font $Font6 \
	    -variable  latticeNeighbours_number(1) -value 1
    .neighbours.nnNum1.menu add radiobutton -label "#nn=2" -font $Font6 \
	    -variable  latticeNeighbours_number(1) -value 2
    .neighbours.nnNum1.menu add radiobutton -label "#nn=3" -font $Font6 \
	    -variable  latticeNeighbours_number(1) -value 3
    .neighbours.nnNum1.menu add radiobutton -label "#nn=4" -font $Font6 \
	    -variable  latticeNeighbours_number(1) -value 4
    .neighbours.nnNum1.menu add radiobutton -label "#nn=5" -font $Font6 \
	    -variable  latticeNeighbours_number(1) -value 5
    .neighbours.nnNum1.menu add radiobutton -label "#nn=6" -font $Font6 \
	    -variable  latticeNeighbours_number(1) -value 6
    .neighbours.nnNum1.menu add radiobutton -label "#nn=7" -font $Font6 \
	    -variable  latticeNeighbours_number(1) -value 7
    .neighbours.nnNum1.menu add radiobutton -label "#nn=8" -font $Font6 \
	    -variable  latticeNeighbours_number(1) -value 8
    
    
    label .neighbours.l11     -font $Font6 -text "1"
    entry .neighbours.e11x    -relief sunken -width 2 -textvariable latticeNeighbours_x(1,1)
    entry .neighbours.e11y    -relief sunken -width 2 -textvariable latticeNeighbours_y(1,1)
    entry .neighbours.e11z    -relief sunken -width 2 -textvariable latticeNeighbours_z(1,1)
    entry .neighbours.e11cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(1,1)
    
    label .neighbours.l12     -font $Font6 -text "2"
    entry .neighbours.e12x    -relief sunken -width 2 -textvariable latticeNeighbours_x(1,2)
    entry .neighbours.e12y    -relief sunken -width 2 -textvariable latticeNeighbours_y(1,2)
    entry .neighbours.e12z    -relief sunken -width 2 -textvariable latticeNeighbours_z(1,2)
    entry .neighbours.e12cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(1,2)

    label .neighbours.l13     -font $Font6 -text "3"
    entry .neighbours.e13x    -relief sunken -width 2 -textvariable latticeNeighbours_x(1,3)
    entry .neighbours.e13y    -relief sunken -width 2 -textvariable latticeNeighbours_y(1,3)
    entry .neighbours.e13z    -relief sunken -width 2 -textvariable latticeNeighbours_z(1,3)
    entry .neighbours.e13cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(1,3)

    label .neighbours.l14     -font $Font6 -text "4"
    entry .neighbours.e14x    -relief sunken -width 2 -textvariable latticeNeighbours_x(1,4)
    entry .neighbours.e14y    -relief sunken -width 2 -textvariable latticeNeighbours_y(1,4)
    entry .neighbours.e14z    -relief sunken -width 2 -textvariable latticeNeighbours_z(1,4)
    entry .neighbours.e14cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(1,4)

    label .neighbours.l15     -font $Font6 -text "5"
    entry .neighbours.e15x    -relief sunken -width 2 -textvariable latticeNeighbours_x(1,5)
    entry .neighbours.e15y    -relief sunken -width 2 -textvariable latticeNeighbours_y(1,5)
    entry .neighbours.e15z    -relief sunken -width 2 -textvariable latticeNeighbours_z(1,5)
    entry .neighbours.e15cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(1,5)

    label .neighbours.l16     -font $Font6 -text "6"
    entry .neighbours.e16x    -relief sunken -width 2 -textvariable latticeNeighbours_x(1,6)
    entry .neighbours.e16y    -relief sunken -width 2 -textvariable latticeNeighbours_y(1,6)
    entry .neighbours.e16z    -relief sunken -width 2 -textvariable latticeNeighbours_z(1,6)
    entry .neighbours.e16cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(1,6)

    label .neighbours.l17     -font $Font6 -text "7"
    entry .neighbours.e17x    -relief sunken -width 2 -textvariable latticeNeighbours_x(1,7)
    entry .neighbours.e17y    -relief sunken -width 2 -textvariable latticeNeighbours_y(1,7)
    entry .neighbours.e17z    -relief sunken -width 2 -textvariable latticeNeighbours_z(1,7)
    entry .neighbours.e17cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(1,7)

    label .neighbours.l18     -font $Font6 -text "8"
    entry .neighbours.e18x    -relief sunken -width 2 -textvariable latticeNeighbours_x(1,8)
    entry .neighbours.e18y    -relief sunken -width 2 -textvariable latticeNeighbours_y(1,8)
    entry .neighbours.e18z    -relief sunken -width 2 -textvariable latticeNeighbours_z(1,8)
    entry .neighbours.e18cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(1,8)

    if { $latticeNeighbours_number(1) >= 1 } {
	grid config .neighbours.nnNum1         -column 0 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.l11            -column 1 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e11x           -column 2 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e11y           -column 3 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e11z           -column 4 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e11cell        -column 5 -row 0 -sticky e -pady 2 -padx 2
    } 
    if { $latticeNeighbours_number(1) >= 2 } { 
	grid config .neighbours.l12            -column 6  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e12x           -column 7  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e12y           -column 8 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e12z           -column 9 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e12cell        -column 10 -row 0 -sticky e -pady 2 -padx 2
    } 
    if { $latticeNeighbours_number(1) >= 3 } { 
	grid config .neighbours.l13            -column 11  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e13x           -column 12 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e13y           -column 13 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e13z           -column 14 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e13cell        -column 15 -row 0 -sticky e -pady 2 -padx 2
    } 
    if { $latticeNeighbours_number(1) >= 4 } { 
	grid config .neighbours.l14            -column 16  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e14x           -column 17  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e14y           -column 18 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e14z           -column 19 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e14cell        -column 20 -row 0 -sticky e -pady 2 -padx 2
    } 
    if { $latticeNeighbours_number(1) >= 5 } { 
	grid config .neighbours.l15            -column 21  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e15x           -column 22  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e15y           -column 23 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e15z           -column 24 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e15cell        -column 25 -row 0 -sticky e -pady 2 -padx 2
    } 
    if { $latticeNeighbours_number(1) >= 6 } { 
	grid config .neighbours.l16            -column 26  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e16x           -column 27  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e16y           -column 28 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e16z           -column 29 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e16cell        -column 30 -row 0 -sticky e -pady 2 -padx 2
    } 
    if { $latticeNeighbours_number(1) >= 7 } { 
	grid config .neighbours.l17            -column 31  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e17x           -column 32  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e17y           -column 33 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e17z           -column 34 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e17cell        -column 35 -row 0 -sticky e -pady 2 -padx 2
    } 
    if { $latticeNeighbours_number(1) >= 8 } { 
	grid config .neighbours.l18            -column 36 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e18x           -column 37  -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e18y           -column 38 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e18z           -column 39 -row 0 -sticky e -pady 2 -padx 2
	grid config .neighbours.e18cell        -column 40 -row 0 -sticky e -pady 2 -padx 2
    } 

#   unitcell 2

    menubutton .neighbours.nnNum2 -text "UC#2: #NNs"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .neighbours.nnNum2.menu
    
    menu .neighbours.nnNum2.menu  -background blue  -foreground white
    
    .neighbours.nnNum2.menu add radiobutton -label "#nn=1" -font $Font6 \
	    -variable  latticeNeighbours_number(2) -value 1
    .neighbours.nnNum2.menu add radiobutton -label "#nn=2" -font $Font6 \
	    -variable  latticeNeighbours_number(2) -value 2
    .neighbours.nnNum2.menu add radiobutton -label "#nn=3" -font $Font6 \
	    -variable  latticeNeighbours_number(2) -value 3
    .neighbours.nnNum2.menu add radiobutton -label "#nn=4" -font $Font6 \
	    -variable  latticeNeighbours_number(2) -value 4
    .neighbours.nnNum2.menu add radiobutton -label "#nn=5" -font $Font6 \
	    -variable  latticeNeighbours_number(2) -value 5
    .neighbours.nnNum2.menu add radiobutton -label "#nn=6" -font $Font6 \
	    -variable  latticeNeighbours_number(2) -value 6
    .neighbours.nnNum2.menu add radiobutton -label "#nn=7" -font $Font6 \
	    -variable  latticeNeighbours_number(2) -value 7
    .neighbours.nnNum2.menu add radiobutton -label "#nn=8" -font $Font6 \
	    -variable  latticeNeighbours_number(2) -value 8
    

    label .neighbours.l21     -font $Font6 -text "1"
    entry .neighbours.e21x    -relief sunken -width 2 -textvariable latticeNeighbours_x(2,1)
    entry .neighbours.e21y    -relief sunken -width 2 -textvariable latticeNeighbours_y(2,1)
    entry .neighbours.e21z    -relief sunken -width 2 -textvariable latticeNeighbours_z(2,1)
    entry .neighbours.e21cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(2,1)
    
    label .neighbours.l22     -font $Font6 -text "2"
    entry .neighbours.e22x    -relief sunken -width 2 -textvariable latticeNeighbours_x(2,2)
    entry .neighbours.e22y    -relief sunken -width 2 -textvariable latticeNeighbours_y(2,2)
    entry .neighbours.e22z    -relief sunken -width 2 -textvariable latticeNeighbours_z(2,2)
    entry .neighbours.e22cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(2,2)

    label .neighbours.l23     -font $Font6 -text "3"
    entry .neighbours.e23x    -relief sunken -width 2 -textvariable latticeNeighbours_x(2,3)
    entry .neighbours.e23y    -relief sunken -width 2 -textvariable latticeNeighbours_y(2,3)
    entry .neighbours.e23z    -relief sunken -width 2 -textvariable latticeNeighbours_z(2,3)
    entry .neighbours.e23cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(2,3)

    label .neighbours.l24     -font $Font6 -text "4"
    entry .neighbours.e24x    -relief sunken -width 2 -textvariable latticeNeighbours_x(2,4)
    entry .neighbours.e24y    -relief sunken -width 2 -textvariable latticeNeighbours_y(2,4)
    entry .neighbours.e24z    -relief sunken -width 2 -textvariable latticeNeighbours_z(2,4)
    entry .neighbours.e24cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(2,4)

    label .neighbours.l25     -font $Font6 -text "5"
    entry .neighbours.e25x    -relief sunken -width 2 -textvariable latticeNeighbours_x(2,5)
    entry .neighbours.e25y    -relief sunken -width 2 -textvariable latticeNeighbours_y(2,5)
    entry .neighbours.e25z    -relief sunken -width 2 -textvariable latticeNeighbours_z(2,5)
    entry .neighbours.e25cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(2,5)

    label .neighbours.l26     -font $Font6 -text "6"
    entry .neighbours.e26x    -relief sunken -width 2 -textvariable latticeNeighbours_x(2,6)
    entry .neighbours.e26y    -relief sunken -width 2 -textvariable latticeNeighbours_y(2,6)
    entry .neighbours.e26z    -relief sunken -width 2 -textvariable latticeNeighbours_z(2,6)
    entry .neighbours.e26cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(2,6)

    label .neighbours.l27     -font $Font6 -text "7"
    entry .neighbours.e27x    -relief sunken -width 2 -textvariable latticeNeighbours_x(2,7)
    entry .neighbours.e27y    -relief sunken -width 2 -textvariable latticeNeighbours_y(2,7)
    entry .neighbours.e27z    -relief sunken -width 2 -textvariable latticeNeighbours_z(2,7)
    entry .neighbours.e27cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(2,7)

    label .neighbours.l28     -font $Font6 -text "8"
    entry .neighbours.e28x    -relief sunken -width 2 -textvariable latticeNeighbours_x(2,8)
    entry .neighbours.e28y    -relief sunken -width 2 -textvariable latticeNeighbours_y(2,8)
    entry .neighbours.e28z    -relief sunken -width 2 -textvariable latticeNeighbours_z(2,8)
    entry .neighbours.e28cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(2,8)

    if { $unitCell_number >= 2} {
	
	if { $latticeNeighbours_number(2) >= 1 } {
	    grid config .neighbours.nnNum2         -column 0 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.l21            -column 1 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e21x           -column 2 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e21y           -column 3 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e21z           -column 4 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e21cell        -column 5 -row 1 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(2) >= 2 } { 
	    grid config .neighbours.l22            -column 6  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e22x           -column 7  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e22y           -column 8 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e22z           -column 9 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e22cell        -column 10 -row 1 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(2) >= 3 } { 
	    grid config .neighbours.l23            -column 11  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e23x           -column 12 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e23y           -column 13 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e23z           -column 14 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e23cell        -column 15 -row 1 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(2) >= 4 } { 
	    grid config .neighbours.l24            -column 16  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e24x           -column 17  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e24y           -column 18 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e24z           -column 19 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e24cell        -column 20 -row 1 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(2) >= 5 } { 
	    grid config .neighbours.l25            -column 21  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e25x           -column 22  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e25y           -column 23 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e25z           -column 24 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e25cell        -column 25 -row 1 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(2) >= 6 } { 
	    grid config .neighbours.l26            -column 26  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e26x           -column 27  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e26y           -column 28 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e26z           -column 29 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e26cell        -column 30 -row 1 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(2) >= 7 } { 
	    grid config .neighbours.l27            -column 31  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e27x           -column 32  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e27y           -column 33 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e27z           -column 34 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e27cell        -column 35 -row 1 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(2) >= 8 } { 
	    grid config .neighbours.l28            -column 36 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e28x           -column 37  -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e28y           -column 38 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e28z           -column 39 -row 1 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e28cell        -column 40 -row 1 -sticky e -pady 2 -padx 2
	} 
	
    }
#   unitcell 3

    menubutton .neighbours.nnNum3 -text "UC#3: #NNs"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .neighbours.nnNum3.menu
    
    menu .neighbours.nnNum3.menu  -background blue  -foreground white
    
    .neighbours.nnNum3.menu add radiobutton -label "#nn=1" -font $Font6 \
	    -variable  latticeNeighbours_number(3) -value 1
    .neighbours.nnNum3.menu add radiobutton -label "#nn=2" -font $Font6 \
	    -variable  latticeNeighbours_number(3) -value 2
    .neighbours.nnNum3.menu add radiobutton -label "#nn=3" -font $Font6 \
	    -variable  latticeNeighbours_number(3) -value 3
    .neighbours.nnNum3.menu add radiobutton -label "#nn=4" -font $Font6 \
	    -variable  latticeNeighbours_number(3) -value 4
    .neighbours.nnNum3.menu add radiobutton -label "#nn=5" -font $Font6 \
	    -variable  latticeNeighbours_number(3) -value 5
    .neighbours.nnNum3.menu add radiobutton -label "#nn=6" -font $Font6 \
	    -variable  latticeNeighbours_number(3) -value 6
    .neighbours.nnNum3.menu add radiobutton -label "#nn=7" -font $Font6 \
	    -variable  latticeNeighbours_number(3) -value 7
    .neighbours.nnNum3.menu add radiobutton -label "#nn=8" -font $Font6 \
	    -variable  latticeNeighbours_number(3) -value 8
    

    label .neighbours.l31     -font $Font6 -text "1"
    entry .neighbours.e31x    -relief sunken -width 2 -textvariable latticeNeighbours_x(3,1)
    entry .neighbours.e31y    -relief sunken -width 2 -textvariable latticeNeighbours_y(3,1)
    entry .neighbours.e31z    -relief sunken -width 2 -textvariable latticeNeighbours_z(3,1)
    entry .neighbours.e31cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(3,1)
    
    label .neighbours.l32     -font $Font6 -text "2"
    entry .neighbours.e32x    -relief sunken -width 2 -textvariable latticeNeighbours_x(3,2)
    entry .neighbours.e32y    -relief sunken -width 2 -textvariable latticeNeighbours_y(3,2)
    entry .neighbours.e32z    -relief sunken -width 2 -textvariable latticeNeighbours_z(3,2)
    entry .neighbours.e32cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(3,2)

    label .neighbours.l33     -font $Font6 -text "3"
    entry .neighbours.e33x    -relief sunken -width 2 -textvariable latticeNeighbours_x(3,3)
    entry .neighbours.e33y    -relief sunken -width 2 -textvariable latticeNeighbours_y(3,3)
    entry .neighbours.e33z    -relief sunken -width 2 -textvariable latticeNeighbours_z(3,3)
    entry .neighbours.e33cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(3,3)

    label .neighbours.l34     -font $Font6 -text "4"
    entry .neighbours.e34x    -relief sunken -width 2 -textvariable latticeNeighbours_x(3,4)
    entry .neighbours.e34y    -relief sunken -width 2 -textvariable latticeNeighbours_y(3,4)
    entry .neighbours.e34z    -relief sunken -width 2 -textvariable latticeNeighbours_z(3,4)
    entry .neighbours.e34cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(3,4)

    label .neighbours.l35     -font $Font6 -text "5"
    entry .neighbours.e35x    -relief sunken -width 2 -textvariable latticeNeighbours_x(3,5)
    entry .neighbours.e35y    -relief sunken -width 2 -textvariable latticeNeighbours_y(3,5)
    entry .neighbours.e35z    -relief sunken -width 2 -textvariable latticeNeighbours_z(3,5)
    entry .neighbours.e35cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(3,5)

    label .neighbours.l36     -font $Font6 -text "6"
    entry .neighbours.e36x    -relief sunken -width 2 -textvariable latticeNeighbours_x(3,6)
    entry .neighbours.e36y    -relief sunken -width 2 -textvariable latticeNeighbours_y(3,6)
    entry .neighbours.e36z    -relief sunken -width 2 -textvariable latticeNeighbours_z(3,6)
    entry .neighbours.e36cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(3,6)

    label .neighbours.l37     -font $Font6 -text "7"
    entry .neighbours.e37x    -relief sunken -width 2 -textvariable latticeNeighbours_x(3,7)
    entry .neighbours.e37y    -relief sunken -width 2 -textvariable latticeNeighbours_y(3,7)
    entry .neighbours.e37z    -relief sunken -width 2 -textvariable latticeNeighbours_z(3,7)
    entry .neighbours.e37cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(3,7)

    label .neighbours.l38     -font $Font6 -text "8"
    entry .neighbours.e38x    -relief sunken -width 2 -textvariable latticeNeighbours_x(3,8)
    entry .neighbours.e38y    -relief sunken -width 2 -textvariable latticeNeighbours_y(3,8)
    entry .neighbours.e38z    -relief sunken -width 2 -textvariable latticeNeighbours_z(3,8)
    entry .neighbours.e38cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(3,8)

    if { $unitCell_number >= 3} {
	
	if { $latticeNeighbours_number(3) >= 1 } {
	    grid config .neighbours.nnNum3         -column 0 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.l31            -column 1 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e31x           -column 2 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e31y           -column 3 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e31z           -column 4 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e31cell        -column 5 -row 2 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(3) >= 2 } { 
	    grid config .neighbours.l32            -column 6  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e32x           -column 7  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e32y           -column 8 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e32z           -column 9 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e32cell        -column 10 -row 2 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(3) >= 3 } { 
	    grid config .neighbours.l33            -column 11  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e33x           -column 12 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e33y           -column 13 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e33z           -column 14 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e33cell        -column 15 -row 2 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(3) >= 4 } { 
	    grid config .neighbours.l34            -column 16  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e34x           -column 17  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e34y           -column 18 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e34z           -column 19 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e34cell        -column 20 -row 2 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(3) >= 5 } { 
	    grid config .neighbours.l35            -column 21  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e35x           -column 22  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e35y           -column 23 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e35z           -column 24 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e35cell        -column 25 -row 2 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(3) >= 6 } { 
	    grid config .neighbours.l36            -column 26  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e36x           -column 27  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e36y           -column 28 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e36z           -column 29 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e36cell        -column 30 -row 2 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(3) >= 7 } { 
	    grid config .neighbours.l37            -column 31  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e37x           -column 32  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e37y           -column 33 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e37z           -column 34 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e37cell        -column 35 -row 2 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(3) >= 8 } { 
	    grid config .neighbours.l38            -column 36 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e38x           -column 37  -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e38y           -column 38 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e38z           -column 39 -row 2 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e38cell        -column 40 -row 2 -sticky e -pady 2 -padx 2
	} 
	
    }

#   unitcell 4

    menubutton .neighbours.nnNum4 -text "UC#4: #NNs"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .neighbours.nnNum4.menu
    
    menu .neighbours.nnNum4.menu  -background blue  -foreground white
    
    .neighbours.nnNum4.menu add radiobutton -label "#nn=1" -font $Font6 \
	    -variable  latticeNeighbours_number(4) -value 1
    .neighbours.nnNum4.menu add radiobutton -label "#nn=2" -font $Font6 \
	    -variable  latticeNeighbours_number(4) -value 2
    .neighbours.nnNum4.menu add radiobutton -label "#nn=3" -font $Font6 \
	    -variable  latticeNeighbours_number(4) -value 3
    .neighbours.nnNum4.menu add radiobutton -label "#nn=4" -font $Font6 \
	    -variable  latticeNeighbours_number(4) -value 4
    .neighbours.nnNum4.menu add radiobutton -label "#nn=5" -font $Font6 \
	    -variable  latticeNeighbours_number(4) -value 5
    .neighbours.nnNum4.menu add radiobutton -label "#nn=6" -font $Font6 \
	    -variable  latticeNeighbours_number(4) -value 6
    .neighbours.nnNum4.menu add radiobutton -label "#nn=7" -font $Font6 \
	    -variable  latticeNeighbours_number(4) -value 7
    .neighbours.nnNum4.menu add radiobutton -label "#nn=8" -font $Font6 \
	    -variable  latticeNeighbours_number(4) -value 8
    

    label .neighbours.l41     -font $Font6 -text "1"
    entry .neighbours.e41x    -relief sunken -width 2 -textvariable latticeNeighbours_x(4,1)
    entry .neighbours.e41y    -relief sunken -width 2 -textvariable latticeNeighbours_y(4,1)
    entry .neighbours.e41z    -relief sunken -width 2 -textvariable latticeNeighbours_z(4,1)
    entry .neighbours.e41cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(4,1)
    
    label .neighbours.l42     -font $Font6 -text "2"
    entry .neighbours.e42x    -relief sunken -width 2 -textvariable latticeNeighbours_x(4,2)
    entry .neighbours.e42y    -relief sunken -width 2 -textvariable latticeNeighbours_y(4,2)
    entry .neighbours.e42z    -relief sunken -width 2 -textvariable latticeNeighbours_z(4,2)
    entry .neighbours.e42cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(4,2)

    label .neighbours.l43     -font $Font6 -text "3"
    entry .neighbours.e43x    -relief sunken -width 2 -textvariable latticeNeighbours_x(4,3)
    entry .neighbours.e43y    -relief sunken -width 2 -textvariable latticeNeighbours_y(4,3)
    entry .neighbours.e43z    -relief sunken -width 2 -textvariable latticeNeighbours_z(4,3)
    entry .neighbours.e43cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(4,3)

    label .neighbours.l44     -font $Font6 -text "4"
    entry .neighbours.e44x    -relief sunken -width 2 -textvariable latticeNeighbours_x(4,4)
    entry .neighbours.e44y    -relief sunken -width 2 -textvariable latticeNeighbours_y(4,4)
    entry .neighbours.e44z    -relief sunken -width 2 -textvariable latticeNeighbours_z(4,4)
    entry .neighbours.e44cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(4,4)

    label .neighbours.l45     -font $Font6 -text "5"
    entry .neighbours.e45x    -relief sunken -width 2 -textvariable latticeNeighbours_x(4,5)
    entry .neighbours.e45y    -relief sunken -width 2 -textvariable latticeNeighbours_y(4,5)
    entry .neighbours.e45z    -relief sunken -width 2 -textvariable latticeNeighbours_z(4,5)
    entry .neighbours.e45cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(4,5)

    label .neighbours.l46     -font $Font6 -text "6"
    entry .neighbours.e46x    -relief sunken -width 2 -textvariable latticeNeighbours_x(4,6)
    entry .neighbours.e46y    -relief sunken -width 2 -textvariable latticeNeighbours_y(4,6)
    entry .neighbours.e46z    -relief sunken -width 2 -textvariable latticeNeighbours_z(4,6)
    entry .neighbours.e46cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(4,6)

    label .neighbours.l47     -font $Font6 -text "7"
    entry .neighbours.e47x    -relief sunken -width 2 -textvariable latticeNeighbours_x(4,7)
    entry .neighbours.e47y    -relief sunken -width 2 -textvariable latticeNeighbours_y(4,7)
    entry .neighbours.e47z    -relief sunken -width 2 -textvariable latticeNeighbours_z(4,7)
    entry .neighbours.e47cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(4,7)

    label .neighbours.l48     -font $Font6 -text "8"
    entry .neighbours.e48x    -relief sunken -width 2 -textvariable latticeNeighbours_x(4,8)
    entry .neighbours.e48y    -relief sunken -width 2 -textvariable latticeNeighbours_y(4,8)
    entry .neighbours.e48z    -relief sunken -width 2 -textvariable latticeNeighbours_z(4,8)
    entry .neighbours.e48cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(4,8)

    if { $unitCell_number >= 4} {
	
	if { $latticeNeighbours_number(4) >= 1 } {
	    grid config .neighbours.nnNum4         -column 0 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.l41            -column 1 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e41x           -column 2 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e41y           -column 3 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e41z           -column 4 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e41cell        -column 5 -row 3 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(4) >= 2 } { 
	    grid config .neighbours.l42            -column 6  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e42x           -column 7  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e42y           -column 8 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e42z           -column 9 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e42cell        -column 10 -row 3 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(4) >= 3 } { 
	    grid config .neighbours.l43            -column 11  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e43x           -column 12 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e43y           -column 13 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e43z           -column 14 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e43cell        -column 15 -row 3 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(4) >= 4 } { 
	    grid config .neighbours.l44            -column 16  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e44x           -column 17  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e44y           -column 18 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e44z           -column 19 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e44cell        -column 20 -row 3 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(4) >= 5 } { 
	    grid config .neighbours.l45            -column 21  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e45x           -column 22  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e45y           -column 23 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e45z           -column 24 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e45cell        -column 25 -row 3 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(4) >= 6 } { 
	    grid config .neighbours.l46            -column 26  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e46x           -column 27  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e46y           -column 28 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e46z           -column 29 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e46cell        -column 30 -row 3 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(4) >= 7 } { 
	    grid config .neighbours.l47            -column 31  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e47x           -column 32  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e47y           -column 33 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e47z           -column 34 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e47cell        -column 35 -row 3 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(4) >= 8 } { 
	    grid config .neighbours.l48            -column 36 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e48x           -column 37  -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e48y           -column 38 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e48z           -column 39 -row 3 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e48cell        -column 40 -row 3 -sticky e -pady 2 -padx 2
	} 
	
    }

#   unitcell 5

    menubutton .neighbours.nnNum5 -text "UC#5: #NNs"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .neighbours.nnNum5.menu
    
    menu .neighbours.nnNum5.menu  -background blue  -foreground white
    
    .neighbours.nnNum5.menu add radiobutton -label "#nn=1" -font $Font6 \
	    -variable  latticeNeighbours_number(5) -value 1
    .neighbours.nnNum5.menu add radiobutton -label "#nn=2" -font $Font6 \
	    -variable  latticeNeighbours_number(5) -value 2
    .neighbours.nnNum5.menu add radiobutton -label "#nn=3" -font $Font6 \
	    -variable  latticeNeighbours_number(5) -value 3
    .neighbours.nnNum5.menu add radiobutton -label "#nn=4" -font $Font6 \
	    -variable  latticeNeighbours_number(5) -value 4
    .neighbours.nnNum5.menu add radiobutton -label "#nn=5" -font $Font6 \
	    -variable  latticeNeighbours_number(5) -value 5
    .neighbours.nnNum5.menu add radiobutton -label "#nn=6" -font $Font6 \
	    -variable  latticeNeighbours_number(5) -value 6
    .neighbours.nnNum5.menu add radiobutton -label "#nn=7" -font $Font6 \
	    -variable  latticeNeighbours_number(5) -value 7
    .neighbours.nnNum5.menu add radiobutton -label "#nn=8" -font $Font6 \
	    -variable  latticeNeighbours_number(5) -value 8
    

    label .neighbours.l51     -font $Font6 -text "1"
    entry .neighbours.e51x    -relief sunken -width 2 -textvariable latticeNeighbours_x(5,1)
    entry .neighbours.e51y    -relief sunken -width 2 -textvariable latticeNeighbours_y(5,1)
    entry .neighbours.e51z    -relief sunken -width 2 -textvariable latticeNeighbours_z(5,1)
    entry .neighbours.e51cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(5,1)
    
    label .neighbours.l52     -font $Font6 -text "2"
    entry .neighbours.e52x    -relief sunken -width 2 -textvariable latticeNeighbours_x(5,2)
    entry .neighbours.e52y    -relief sunken -width 2 -textvariable latticeNeighbours_y(5,2)
    entry .neighbours.e52z    -relief sunken -width 2 -textvariable latticeNeighbours_z(5,2)
    entry .neighbours.e52cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(5,2)

    label .neighbours.l53     -font $Font6 -text "3"
    entry .neighbours.e53x    -relief sunken -width 2 -textvariable latticeNeighbours_x(5,3)
    entry .neighbours.e53y    -relief sunken -width 2 -textvariable latticeNeighbours_y(5,3)
    entry .neighbours.e53z    -relief sunken -width 2 -textvariable latticeNeighbours_z(5,3)
    entry .neighbours.e53cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(5,3)

    label .neighbours.l54     -font $Font6 -text "4"
    entry .neighbours.e54x    -relief sunken -width 2 -textvariable latticeNeighbours_x(5,4)
    entry .neighbours.e54y    -relief sunken -width 2 -textvariable latticeNeighbours_y(5,4)
    entry .neighbours.e54z    -relief sunken -width 2 -textvariable latticeNeighbours_z(5,4)
    entry .neighbours.e54cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(5,4)

    label .neighbours.l55     -font $Font6 -text "5"
    entry .neighbours.e55x    -relief sunken -width 2 -textvariable latticeNeighbours_x(5,5)
    entry .neighbours.e55y    -relief sunken -width 2 -textvariable latticeNeighbours_y(5,5)
    entry .neighbours.e55z    -relief sunken -width 2 -textvariable latticeNeighbours_z(5,5)
    entry .neighbours.e55cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(5,5)

    label .neighbours.l56     -font $Font6 -text "6"
    entry .neighbours.e56x    -relief sunken -width 2 -textvariable latticeNeighbours_x(5,6)
    entry .neighbours.e56y    -relief sunken -width 2 -textvariable latticeNeighbours_y(5,6)
    entry .neighbours.e56z    -relief sunken -width 2 -textvariable latticeNeighbours_z(5,6)
    entry .neighbours.e56cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(5,6)

    label .neighbours.l57     -font $Font6 -text "7"
    entry .neighbours.e57x    -relief sunken -width 2 -textvariable latticeNeighbours_x(5,7)
    entry .neighbours.e57y    -relief sunken -width 2 -textvariable latticeNeighbours_y(5,7)
    entry .neighbours.e57z    -relief sunken -width 2 -textvariable latticeNeighbours_z(5,7)
    entry .neighbours.e57cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(5,7)

    label .neighbours.l58     -font $Font6 -text "8"
    entry .neighbours.e58x    -relief sunken -width 2 -textvariable latticeNeighbours_x(5,8)
    entry .neighbours.e58y    -relief sunken -width 2 -textvariable latticeNeighbours_y(5,8)
    entry .neighbours.e58z    -relief sunken -width 2 -textvariable latticeNeighbours_z(5,8)
    entry .neighbours.e58cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(5,8)

    if { $unitCell_number >= 5} {
	
	if { $latticeNeighbours_number(5) >= 1 } {
	    grid config .neighbours.nnNum5         -column 0 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.l51            -column 1 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e51x           -column 2 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e51y           -column 3 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e51z           -column 4 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e51cell        -column 5 -row 4 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(5) >= 2 } { 
	    grid config .neighbours.l52            -column 6  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e52x           -column 7  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e52y           -column 8 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e52z           -column 9 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e52cell        -column 10 -row 4 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(5) >= 3 } { 
	    grid config .neighbours.l53            -column 11  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e53x           -column 12 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e53y           -column 13 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e53z           -column 14 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e53cell        -column 15 -row 4 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(5) >= 4 } { 
	    grid config .neighbours.l54            -column 16  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e54x           -column 17  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e54y           -column 18 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e54z           -column 19 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e54cell        -column 20 -row 4 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(5) >= 5 } { 
	    grid config .neighbours.l55            -column 21  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e55x           -column 22  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e55y           -column 23 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e55z           -column 24 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e55cell        -column 25 -row 4 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(5) >= 6 } { 
	    grid config .neighbours.l56            -column 26  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e56x           -column 27  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e56y           -column 28 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e56z           -column 29 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e56cell        -column 30 -row 4 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(5) >= 7 } { 
	    grid config .neighbours.l57            -column 31  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e57x           -column 32  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e57y           -column 33 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e57z           -column 34 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e57cell        -column 35 -row 4 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(5) >= 8 } { 
	    grid config .neighbours.l58            -column 36 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e58x           -column 37  -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e58y           -column 38 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e58z           -column 39 -row 4 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e58cell        -column 40 -row 4 -sticky e -pady 2 -padx 2
	} 
	
    }
#   unitcell 6

    menubutton .neighbours.nnNum6 -text "UC#6: #NNs"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .neighbours.nnNum6.menu
    
    menu .neighbours.nnNum6.menu  -background blue  -foreground white
    
    .neighbours.nnNum6.menu add radiobutton -label "#nn=1" -font $Font6 \
	    -variable  latticeNeighbours_number(6) -value 1
    .neighbours.nnNum6.menu add radiobutton -label "#nn=2" -font $Font6 \
	    -variable  latticeNeighbours_number(6) -value 2
    .neighbours.nnNum6.menu add radiobutton -label "#nn=3" -font $Font6 \
	    -variable  latticeNeighbours_number(6) -value 3
    .neighbours.nnNum6.menu add radiobutton -label "#nn=4" -font $Font6 \
	    -variable  latticeNeighbours_number(6) -value 4
    .neighbours.nnNum6.menu add radiobutton -label "#nn=5" -font $Font6 \
	    -variable  latticeNeighbours_number(6) -value 5
    .neighbours.nnNum6.menu add radiobutton -label "#nn=6" -font $Font6 \
	    -variable  latticeNeighbours_number(6) -value 6
    .neighbours.nnNum6.menu add radiobutton -label "#nn=7" -font $Font6 \
	    -variable  latticeNeighbours_number(6) -value 7
    .neighbours.nnNum6.menu add radiobutton -label "#nn=8" -font $Font6 \
	    -variable  latticeNeighbours_number(6) -value 8
    

    label .neighbours.l61     -font $Font6 -text "1"
    entry .neighbours.e61x    -relief sunken -width 2 -textvariable latticeNeighbours_x(6,1)
    entry .neighbours.e61y    -relief sunken -width 2 -textvariable latticeNeighbours_y(6,1)
    entry .neighbours.e61z    -relief sunken -width 2 -textvariable latticeNeighbours_z(6,1)
    entry .neighbours.e61cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(6,1)
    
    label .neighbours.l62     -font $Font6 -text "2"
    entry .neighbours.e62x    -relief sunken -width 2 -textvariable latticeNeighbours_x(6,2)
    entry .neighbours.e62y    -relief sunken -width 2 -textvariable latticeNeighbours_y(6,2)
    entry .neighbours.e62z    -relief sunken -width 2 -textvariable latticeNeighbours_z(6,2)
    entry .neighbours.e62cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(6,2)

    label .neighbours.l63     -font $Font6 -text "3"
    entry .neighbours.e63x    -relief sunken -width 2 -textvariable latticeNeighbours_x(6,3)
    entry .neighbours.e63y    -relief sunken -width 2 -textvariable latticeNeighbours_y(6,3)
    entry .neighbours.e63z    -relief sunken -width 2 -textvariable latticeNeighbours_z(6,3)
    entry .neighbours.e63cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(6,3)

    label .neighbours.l64     -font $Font6 -text "4"
    entry .neighbours.e64x    -relief sunken -width 2 -textvariable latticeNeighbours_x(6,4)
    entry .neighbours.e64y    -relief sunken -width 2 -textvariable latticeNeighbours_y(6,4)
    entry .neighbours.e64z    -relief sunken -width 2 -textvariable latticeNeighbours_z(6,4)
    entry .neighbours.e64cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(6,4)

    label .neighbours.l65     -font $Font6 -text "5"
    entry .neighbours.e65x    -relief sunken -width 2 -textvariable latticeNeighbours_x(6,5)
    entry .neighbours.e65y    -relief sunken -width 2 -textvariable latticeNeighbours_y(6,5)
    entry .neighbours.e65z    -relief sunken -width 2 -textvariable latticeNeighbours_z(6,5)
    entry .neighbours.e65cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(6,5)

    label .neighbours.l66     -font $Font6 -text "6"
    entry .neighbours.e66x    -relief sunken -width 2 -textvariable latticeNeighbours_x(6,6)
    entry .neighbours.e66y    -relief sunken -width 2 -textvariable latticeNeighbours_y(6,6)
    entry .neighbours.e66z    -relief sunken -width 2 -textvariable latticeNeighbours_z(6,6)
    entry .neighbours.e66cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(6,6)

    label .neighbours.l67     -font $Font6 -text "7"
    entry .neighbours.e67x    -relief sunken -width 2 -textvariable latticeNeighbours_x(6,7)
    entry .neighbours.e67y    -relief sunken -width 2 -textvariable latticeNeighbours_y(6,7)
    entry .neighbours.e67z    -relief sunken -width 2 -textvariable latticeNeighbours_z(6,7)
    entry .neighbours.e67cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(6,7)

    label .neighbours.l68     -font $Font6 -text "8"
    entry .neighbours.e68x    -relief sunken -width 2 -textvariable latticeNeighbours_x(6,8)
    entry .neighbours.e68y    -relief sunken -width 2 -textvariable latticeNeighbours_y(6,8)
    entry .neighbours.e68z    -relief sunken -width 2 -textvariable latticeNeighbours_z(6,8)
    entry .neighbours.e68cell -relief sunken -width 2 -textvariable latticeNeighbours_cell(6,8)

    if { $unitCell_number >= 6} {
	
	if { $latticeNeighbours_number(6) >= 1 } {
	    grid config .neighbours.nnNum6         -column 0 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.l61            -column 1 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e61x           -column 2 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e61y           -column 3 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e61z           -column 4 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e61cell        -column 5 -row 5 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(6) >= 2 } { 
	    grid config .neighbours.l62            -column 6  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e62x           -column 7  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e62y           -column 8 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e62z           -column 9 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e62cell        -column 10 -row 5 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(6) >= 3 } { 
	    grid config .neighbours.l63            -column 11  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e63x           -column 12 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e63y           -column 13 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e63z           -column 14 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e63cell        -column 15 -row 5 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(6) >= 4 } { 
	    grid config .neighbours.l64            -column 16  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e64x           -column 17  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e64y           -column 18 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e64z           -column 19 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e64cell        -column 20 -row 5 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(6) >= 5 } { 
	    grid config .neighbours.l65            -column 21  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e65x           -column 22  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e65y           -column 23 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e65z           -column 24 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e65cell        -column 25 -row 5 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(6) >= 6 } { 
	    grid config .neighbours.l66            -column 26  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e66x           -column 27  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e66y           -column 28 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e66z           -column 29 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e66cell        -column 30 -row 5 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(6) >= 7 } { 
	    grid config .neighbours.l67            -column 31  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e67x           -column 32  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e67y           -column 33 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e67z           -column 34 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e67cell        -column 35 -row 5 -sticky e -pady 2 -padx 2
	} 
	if { $latticeNeighbours_number(6) >= 8 } { 
	    grid config .neighbours.l68            -column 36 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e68x           -column 37  -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e68y           -column 38 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e68z           -column 39 -row 5 -sticky e -pady 2 -padx 2
	    grid config .neighbours.e68cell        -column 40 -row 5 -sticky e -pady 2 -padx 2
	} 
	
    }
    return
}

proc refresh_hamiltonian1 { } {

# Hamiltonian terms 

    global current_bond 
    global current_site 
    global current_term 

    global Font1 
    global Font2 
    global Font3 
    global Font4 
    global Font5 
    global Font6 
    global Font7 

    global directional

    destroy .hamiltonian

#   NOW DO HAMILTONIAN

    frame .hamiltonian -bd 3  
    pack  .hamiltonian -side top -padx 5 -pady 5
    
    label .hamiltonian.l1 -font $Font5 -foreground red \
	    -text "Parameters for Hamiltonian:"
    
    menubutton .hamiltonian.uc -text "Site in UC:"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .hamiltonian.uc.menu  
    
    menu .hamiltonian.uc.menu  -background blue  -foreground white
    .hamiltonian.uc.menu add radiobutton -label "#UC=1" -font $Font6 \
	    -variable  current_site -value 1
    .hamiltonian.uc.menu add radiobutton -label "#UC=2" -font $Font6 \
	    -variable  current_site -value 2
    .hamiltonian.uc.menu add radiobutton -label "#UC=3" -font $Font6 \
	    -variable  current_site -value 3
    .hamiltonian.uc.menu add radiobutton -label "#UC=4" -font $Font6 \
	    -variable  current_site -value 4
    .hamiltonian.uc.menu add radiobutton -label "#UC=5" -font $Font6 \
	    -variable  current_site -value 5
    .hamiltonian.uc.menu add radiobutton -label "#UC=6" -font $Font6 \
	    -variable  current_site -value 6
    
    menubutton .hamiltonian.term -text "Term in Hamiltonian:"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .hamiltonian.term.menu  
    
    menu .hamiltonian.term.menu  -background blue  -foreground white
    .hamiltonian.term.menu add radiobutton -label "s^z s^z" -font $Font6 \
	    -variable  current_term -value 1
    .hamiltonian.term.menu add radiobutton -label "s^z s^+" -font $Font6 \
	    -variable  current_term -value 2
    .hamiltonian.term.menu add radiobutton -label "s^z s^-" -font $Font6 \
	    -variable  current_term -value 3
    .hamiltonian.term.menu add radiobutton -label "s^+ s^z" -font $Font6 \
	    -variable  current_term -value 4
    .hamiltonian.term.menu add radiobutton -label "s^- s^z" -font $Font6 \
	    -variable  current_term -value 5
    .hamiltonian.term.menu add radiobutton -label "s^+ s^-" -font $Font6 \
	    -variable  current_term -value 6
    .hamiltonian.term.menu add radiobutton -label "s^- s^+" -font $Font6 \
	    -variable  current_term -value 7
    .hamiltonian.term.menu add radiobutton -label "s^+ s^+" -font $Font6 \
	    -variable  current_term -value 8
    .hamiltonian.term.menu add radiobutton -label "s^- s^-" -font $Font6 \
	    -variable  current_term -value 9
    .hamiltonian.term.menu add radiobutton -label "s^z" -font $Font6 \
	    -variable  current_term -value 10
    .hamiltonian.term.menu add radiobutton -label "s^-" -font $Font6 \
	    -variable  current_term -value 11
    .hamiltonian.term.menu add radiobutton -label "(s^z)^2" -font $Font6 \
	    -variable  current_term -value 12
    .hamiltonian.term.menu add radiobutton -label "s^+" -font $Font6 \
	-variable  current_term -value 13
    
    menubutton .hamiltonian.bond -text "H_1 or H_2?"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .hamiltonian.bond.menu  
    
    menu .hamiltonian.bond.menu  -background blue  -foreground white
    .hamiltonian.bond.menu add radiobutton -label "H_1" -font $Font6 \
	    -variable  current_bond -value 1
    .hamiltonian.bond.menu add radiobutton -label "H_2" -font $Font6 \
	    -variable  current_bond -value 2
    
    label .hamiltonian.l2 -font $Font5 -foreground red \
	    -text "                        "
    
    menubutton .hamiltonian.directional -text "Directional?"  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .hamiltonian.directional.menu
    
    menu .hamiltonian.directional.menu  -background blue  -foreground white
    .hamiltonian.directional.menu add radiobutton -label "No" -font $Font6 \
	    -variable  directional -value 0
    .hamiltonian.directional.menu add radiobutton -label "Yes" -font $Font6 \
	    -variable  directional -value 1
    
    grid config .hamiltonian.l1    -column 0  -row 0 -sticky e -pady 2 -padx 2
    grid config .hamiltonian.uc    -column 1  -row 0 -sticky w -pady 2 -padx 2
    grid config .hamiltonian.term  -column 2  -row 0 -sticky w -pady 2 -padx 2
    grid config .hamiltonian.bond  -column 3  -row 0 -sticky w -pady 2 -padx 2
    grid config .hamiltonian.l2    -column 5  -row 0 -sticky w -pady 2 -padx 2
    grid config .hamiltonian.directional    -column 4  -row 0 -sticky w -pady 2 -padx 2
    
    
    return
}

proc refresh_hamiltonian2 { } {

# Hamiltonian terms 

    global current_bond 
    global current_site 
    global current_term 

#   define global variables first.

    global Font1 
    global Font2 
    global Font3 
    global Font4 
    global Font5 
    global Font6 
    global Font7 

    global unitCell_number

    global unitCell_x
    global unitCell_y
    global unitCell_z
    global unitCell_s

    global latticeNeighbours_number
    global latticeNeighbours_x
    global latticeNeighbours_y
    global latticeNeighbours_z
    global latticeNeighbours_cell

    global H_k_to_m_number
    global H_k_to_m_x
    global H_k_to_m_y
    global H_k_to_m_z
    global H_k_to_m_cell

    global H_m_to_k_number
    global H_m_to_k_x
    global H_m_to_k_y
    global H_m_to_k_z
    global H_m_to_k_cell

    global directional

    destroy .hamiltonian2 
    
    frame .hamiltonian2 -bd 3  
    pack  .hamiltonian2 -side top -padx 5 -pady 5

    
    if {$current_term == 1} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^z s^z " \
		$current_bond $current_site ]
    } elseif {$current_term == 2} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^z s^+ " \
		$current_bond $current_site ]
    } elseif {$current_term == 3} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^z s^- " \
		$current_bond $current_site ]
    } elseif {$current_term == 4} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^+ s^z " \
		$current_bond $current_site ]
    } elseif {$current_term == 5} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^- s^z " \
		$current_bond $current_site ]
    } elseif {$current_term == 6} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^+ s^- " \
		$current_bond $current_site ]
    } elseif {$current_term == 7} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^- s^+ " \
		$current_bond $current_site ]
    } elseif {$current_term == 8} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^+ s^+ " \
		$current_bond $current_site ]
    } elseif {$current_term == 9} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^- s^- " \
		$current_bond $current_site ]
    } elseif {$current_term == 10} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^z " \
		$current_bond $current_site ]
    } elseif {$current_term == 11} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^- " \
		$current_bond $current_site ]
    } elseif {$current_term == 12} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d Term=(s^z)^2 " \
		$current_bond $current_site ]
    } elseif {$current_term == 13} {
	label .hamiltonian2.l0 -font $Font5 -foreground red \
		-text [format "H_%d Site=%d s^+ " \
		$current_bond $current_site ]
    } 

    menubutton .hamiltonian2.neigh -text "#Ham. Neighs."  -background blue  \
	    -foreground white  -font $Font3 -padx 1m -relief groove\
	    -pady 2 -menu .hamiltonian2.neigh.menu  
    
    menu .hamiltonian2.neigh.menu  -background blue  -foreground white
    .hamiltonian2.neigh.menu add radiobutton -label "#=0" -font $Font6 \
	    -variable  [format \
	    "H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 0
    .hamiltonian2.neigh.menu add radiobutton -label "#=1" -font $Font6 \
	    -variable  [format \
	    "H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 1
    .hamiltonian2.neigh.menu add radiobutton -label "#=2" -font $Font6 \
	    -variable  [format \
	    "H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 2
    .hamiltonian2.neigh.menu add radiobutton -label "#=3" -font $Font6 \
	    -variable  [format \
	    "H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 3
    .hamiltonian2.neigh.menu add radiobutton -label "#=4" -font $Font6 \
	    -variable  [format \
	    "H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 4
    .hamiltonian2.neigh.menu add radiobutton -label "#=5" -font $Font6 \
	    -variable  [format \
	    "H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 5
    .hamiltonian2.neigh.menu add radiobutton -label "#=6" -font $Font6 \
	    -variable  [format \
	    "H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 6
    .hamiltonian2.neigh.menu add radiobutton -label "#=7" -font $Font6 \
	    -variable  [format \
	    "H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 7
    .hamiltonian2.neigh.menu add radiobutton -label "#=8" -font $Font6 \
	    -variable  [format \
	    "H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 8
    
    set one 1
    set two 2
    set three 3
    set four 4
    set five 5
    set six 6
    set seven 7
    set eight 8

    label .hamiltonian2.l1     -font $Font6 -text "1"
    entry .hamiltonian2.e1x    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_x(%d,%d,%d,%d)" $current_bond $current_site $one $current_term]
    entry .hamiltonian2.e1y    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_y(%d,%d,%d,%d)" $current_bond $current_site $one $current_term]
    entry .hamiltonian2.e1z    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_z(%d,%d,%d,%d)" $current_bond $current_site $one $current_term]
    entry .hamiltonian2.e1cell -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_cell(%d,%d,%d,%d)" $current_bond $current_site $one $current_term]
    
    label .hamiltonian2.l2     -font $Font6 -text "2"
    entry .hamiltonian2.e2x    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_x(%d,%d,%d,%d)" $current_bond $current_site $two $current_term]
    entry .hamiltonian2.e2y    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_y(%d,%d,%d,%d)" $current_bond $current_site $two $current_term]
    entry .hamiltonian2.e2z    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_z(%d,%d,%d,%d)" $current_bond $current_site $two $current_term]
    entry .hamiltonian2.e2cell -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_cell(%d,%d,%d,%d)" $current_bond $current_site $two $current_term]

    label .hamiltonian2.l3     -font $Font6 -text "3"
    entry .hamiltonian2.e3x    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_x(%d,%d,%d,%d)" $current_bond $current_site $three $current_term] 
    entry .hamiltonian2.e3y    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_y(%d,%d,%d,%d)" $current_bond $current_site $three $current_term]
    entry .hamiltonian2.e3z    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_z(%d,%d,%d,%d)" $current_bond $current_site $three $current_term]
    entry .hamiltonian2.e3cell -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_cell(%d,%d,%d,%d)" $current_bond $current_site $three $current_term]

    label .hamiltonian2.l4     -font $Font6 -text "4"
    entry .hamiltonian2.e4x    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_x(%d,%d,%d,%d)" $current_bond $current_site $four $current_term] 
    entry .hamiltonian2.e4y    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_y(%d,%d,%d,%d)" $current_bond $current_site $four $current_term] 
    entry .hamiltonian2.e4z    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_z(%d,%d,%d,%d)" $current_bond $current_site $four $current_term]
    entry .hamiltonian2.e4cell -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_cell(%d,%d,%d,%d)" $current_bond $current_site $four $current_term]

    label .hamiltonian2.l5     -font $Font6 -text "5"
    entry .hamiltonian2.e5x    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_x(%d,%d,%d,%d)" $current_bond $current_site $five $current_term]
    entry .hamiltonian2.e5y    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_y(%d,%d,%d,%d)" $current_bond $current_site $five $current_term]
    entry .hamiltonian2.e5z    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_z(%d,%d,%d,%d)" $current_bond $current_site $five $current_term]
    entry .hamiltonian2.e5cell -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_cell(%d,%d,%d,%d)" $current_bond $current_site $five $current_term]

    label .hamiltonian2.l6     -font $Font6 -text "6"
    entry .hamiltonian2.e6x    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_x(%d,%d,%d,%d)" $current_bond $current_site $six $current_term]
    entry .hamiltonian2.e6y    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_y(%d,%d,%d,%d)" $current_bond $current_site $six $current_term]
    entry .hamiltonian2.e6z    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_z(%d,%d,%d,%d)" $current_bond $current_site $six $current_term]
    entry .hamiltonian2.e6cell -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_cell(%d,%d,%d,%d)" $current_bond $current_site $six $current_term]

    label .hamiltonian2.l7     -font $Font6 -text "7"
    entry .hamiltonian2.e7x    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_x(%d,%d,%d,%d)" $current_bond $current_site $seven $current_term]
    entry .hamiltonian2.e7y    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_y(%d,%d,%d,%d)" $current_bond $current_site $seven $current_term]
    entry .hamiltonian2.e7z    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_z(%d,%d,%d,%d)" $current_bond $current_site $seven $current_term]
    entry .hamiltonian2.e7cell -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_cell(%d,%d,%d,%d)" $current_bond $current_site $seven $current_term]

    label .hamiltonian2.l8     -font $Font6 -text "8"
    entry .hamiltonian2.e8x    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_x(%d,%d,%d,%d)" $current_bond $current_site $eight $current_term]
    entry .hamiltonian2.e8y    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_y(%d,%d,%d,%d)" $current_bond $current_site $eight $current_term]
    entry .hamiltonian2.e8z    -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_z(%d,%d,%d,%d)" $current_bond $current_site $eight $current_term]
    entry .hamiltonian2.e8cell -relief sunken -width 2 -textvariable [format \
	    "H_k_to_m_cell(%d,%d,%d,%d)" $current_bond $current_site $eight $current_term]

    label .hamiltonian2.coefflabel1 -font $Font6 -text "  Coeff"
    entry .hamiltonian2.coeffentry1 -relief sunken -width 4 -textvariable \
	    [format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
	    $current_site $one $current_term]
    label .hamiltonian2.coefflabel2 -font $Font6 -text "  Coeff"
    entry .hamiltonian2.coeffentry2 -relief sunken -width 4 -textvariable \
	    [format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
	    $current_site $two $current_term]
    label .hamiltonian2.coefflabel3 -font $Font6 -text "  Coeff"
    entry .hamiltonian2.coeffentry3 -relief sunken -width 4 -textvariable \
	    [format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
	    $current_site $three $current_term]
    label .hamiltonian2.coefflabel4 -font $Font6 -text "  Coeff"
    entry .hamiltonian2.coeffentry4 -relief sunken -width 4 -textvariable \
	    [format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
	    $current_site $four $current_term]
    label .hamiltonian2.coefflabel5 -font $Font6 -text "  Coeff"
    entry .hamiltonian2.coeffentry5 -relief sunken -width 4 -textvariable \
	    [format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
	    $current_site $five $current_term]
    label .hamiltonian2.coefflabel6 -font $Font6 -text "  Coeff"
    entry .hamiltonian2.coeffentry6 -relief sunken -width 4 -textvariable \
	    [format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
	    $current_site $six $current_term]
    label .hamiltonian2.coefflabel7 -font $Font6 -text "  Coeff"
    entry .hamiltonian2.coeffentry7 -relief sunken -width 4 -textvariable \
	    [format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
	    $current_site $seven $current_term]
    label .hamiltonian2.coefflabel8 -font $Font6 -text "  Coeff"
    entry .hamiltonian2.coeffentry8 -relief sunken -width 4 -textvariable \
	    [format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
	    $current_site $eight $current_term]

    if { $directional == 1 && $current_term <= 9} {
	label .hamiltonian2.lnote -font $Font5 -foreground red \
		-text "Directional ---> " 
    } else {
	label .hamiltonian2.lnote -font $Font5 -foreground red \
		-text " " 
    }

    grid config .hamiltonian2.l0            -column 0 -row 0 -sticky e -pady 2 -padx 2
    grid config .hamiltonian2.neigh         -column 1 -row 0 -sticky e -pady 2 -padx 2
    grid config .hamiltonian2.lnote         -column 0 -row 1 -sticky w -pady 2 -padx 2

    if {$current_site > $unitCell_number} {
	set current_site 1 
    }

    if {$current_term >= 10} {
	grid config .hamiltonian2.coefflabel1 \
		-column 2 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.coeffentry1 \
		-column 3 -row 0 -sticky e -pady 2 -padx 2
	set dummy1 [format \
		"set H_k_to_m_number(%d,%d,%d) 0" $current_bond $current_site $current_term]
	eval $dummy1 
    }

    set dummy1 [format \
	    "set tempVar \$H_k_to_m_number(%d,%d,%d)" $current_bond $current_site $current_term]

    eval $dummy1 

    if { $tempVar >= 1 } {
	grid config .hamiltonian2.coefflabel1 \
		-column 2 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.coeffentry1 \
		-column 3 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.l1 \
		-column 4 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e1x \
		-column 5 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e1y \
		-column 6 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e1z  \
		-column 7 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e1cell \
		-column 8 -row 0 -sticky e -pady 2 -padx 2
    } 
    if { $tempVar  >= 2 } { 
	grid config .hamiltonian2.coefflabel2 \
		-column 9 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.coeffentry2 \
		-column 10 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.l2 \
		-column 11  -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e2x \
		-column 12  -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e2y \
		-column 13 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e2z  \
		-column 14 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e2cell \
		-column 15 -row 0 -sticky e -pady 2 -padx 2
    } 
    if { $tempVar  >= 3 } { 
	grid config .hamiltonian2.coefflabel3 \
		-column 16 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.coeffentry3 \
		-column 17 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.l3 \
		-column 18  -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e3x \
		-column 19 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e3y \
		-column 20 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e3z \
		-column 21 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e3cell \
		-column 22 -row 0 -sticky e -pady 2 -padx 2
    }
    if { $tempVar >= 4 } { 
	grid config .hamiltonian2.coefflabel4 \
		-column 23 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.coeffentry4 \
		-column 24 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.l4 \
		-column 25  -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e4x \
		-column 26  -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e4y \
		-column 27 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e4z \
		-column 28 -row 0 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e4cell \
		-column 29 -row 0 -sticky e -pady 2 -padx 2
    } 
    if { $tempVar >= 5 } { 
	grid config .hamiltonian2.coefflabel5 \
		-column 2 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.coeffentry5 \
		-column 3 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.l5 \
		-column 4  -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e5x \
		-column 5  -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e5y \
		-column 6 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e5z \
		-column 7 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e5cell \
		-column 8 -row 1 -sticky e -pady 2 -padx 2
    } 
    if { $tempVar >= 6 } { 
	grid config .hamiltonian2.coefflabel6 \
		-column 9 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.coeffentry6 \
		-column 10 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.l6 \
		-column 11  -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e6x \
		-column 12  -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e6y \
		-column 13 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e6z \
		-column 14 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e6cell \
		-column 15 -row 1 -sticky e -pady 2 -padx 2
    } 
    if { $tempVar >= 7 } { 
	grid config .hamiltonian2.coefflabel7 \
		-column 16 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.coeffentry7 \
		-column 17 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.l7 \
		-column 18  -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e7x \
		-column 19  -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e7y \
		-column 20 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e7z \
		-column 21 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e7cell \
		-column 22 -row 1 -sticky e -pady 2 -padx 2
    } 
    if { $tempVar >= 8 } { 
	grid config .hamiltonian2.coefflabel8 \
		-column 23 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.coeffentry8 \
		-column 24 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.l8 \
		-column 25 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e8x \
		-column 26  -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e8y \
		-column 27 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e8z \
		-column 28 -row 1 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.e8cell \
		-column 29 -row 1 -sticky e -pady 2 -padx 2
    } 
    
    if { $directional == 1 && $current_term <= 9} {

	if {$current_term == 1} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^z s^z " \
		    $current_bond $current_site ]
	} elseif {$current_term == 2} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^z s^+ " \
		    $current_bond $current_site ]
	} elseif {$current_term == 3} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^z s^- " \
		    $current_bond $current_site ]
	} elseif {$current_term == 4} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^+ s^z " \
		    $current_bond $current_site ]
	} elseif {$current_term == 5} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^- s^z " \
		    $current_bond $current_site ]
	} elseif {$current_term == 6} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^+ s^- " \
		    $current_bond $current_site ]
	} elseif {$current_term == 7} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^- s^+ " \
		    $current_bond $current_site ]
	} elseif {$current_term == 8} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^+ s^+ " \
		    $current_bond $current_site ]
	} elseif {$current_term == 9} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^- s^- " \
		    $current_bond $current_site ]
	} elseif {$current_term == 10} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^z " \
		    $current_bond $current_site ]
	} elseif {$current_term == 11} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^- " \
		    $current_bond $current_site ]
	} elseif {$current_term == 12} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d Term=(s^z)^2 " \
		    $current_bond $current_site ]
	} elseif {$current_term == 13} {
	    label .hamiltonian2.l_m_to_k0 -font $Font5 -foreground red \
		    -text [format "H_%d Site=%d s^+ " \
		    $current_bond $current_site ]
	} 

	menubutton .hamiltonian2.neigh_m_to_k -text "#Ham. Neighs."  -background blue  \
		-foreground white  -font $Font3 -padx 1m -relief groove\
		-pady 2 -menu .hamiltonian2.neigh_m_to_k.menu  
	
	menu .hamiltonian2.neigh_m_to_k.menu  -background blue  -foreground white
	.hamiltonian2.neigh_m_to_k.menu add radiobutton -label "#=0" -font $Font6 \
		-variable  [format \
		"H_m_to_k_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 0
	.hamiltonian2.neigh_m_to_k.menu add radiobutton -label "#=1" -font $Font6 \
		-variable  [format \
		"H_m_to_k_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 1
	.hamiltonian2.neigh_m_to_k.menu add radiobutton -label "#=2" -font $Font6 \
		-variable  [format \
		"H_m_to_k_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 2
	.hamiltonian2.neigh_m_to_k.menu add radiobutton -label "#=3" -font $Font6 \
		-variable  [format \
		"H_m_to_k_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 3
	.hamiltonian2.neigh_m_to_k.menu add radiobutton -label "#=4" -font $Font6 \
		-variable  [format \
		"H_m_to_k_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 4
	.hamiltonian2.neigh_m_to_k.menu add radiobutton -label "#=5" -font $Font6 \
		-variable  [format \
		"H_m_to_k_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 5
	.hamiltonian2.neigh_m_to_k.menu add radiobutton -label "#=6" -font $Font6 \
		-variable  [format \
		"H_m_to_k_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 6
	.hamiltonian2.neigh_m_to_k.menu add radiobutton -label "#=7" -font $Font6 \
		-variable  [format \
		"H_m_to_k_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 7
	.hamiltonian2.neigh_m_to_k.menu add radiobutton -label "#=8" -font $Font6 \
		-variable  [format \
		"H_m_to_k_number(%d,%d,%d)" $current_bond $current_site $current_term] -value 8
	
	label .hamiltonian2.l_m_to_k1     -font $Font6 -text "1"
	entry .hamiltonian2.e_m_to_k1x    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_x(%d,%d,%d,%d)" $current_bond $current_site $one $current_term]
	entry .hamiltonian2.e_m_to_k1y    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_y(%d,%d,%d,%d)" $current_bond $current_site $one $current_term]
	entry .hamiltonian2.e_m_to_k1z    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_z(%d,%d,%d,%d)" $current_bond $current_site $one $current_term]
	entry .hamiltonian2.e_m_to_k1cell -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_cell(%d,%d,%d,%d)" $current_bond $current_site $one $current_term]
	
	label .hamiltonian2.l_m_to_k2     -font $Font6 -text "2"
	entry .hamiltonian2.e_m_to_k2x    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_x(%d,%d,%d,%d)" $current_bond $current_site $two $current_term]
	entry .hamiltonian2.e_m_to_k2y    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_y(%d,%d,%d,%d)" $current_bond $current_site $two $current_term]
	entry .hamiltonian2.e_m_to_k2z    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_z(%d,%d,%d,%d)" $current_bond $current_site $two $current_term]
	entry .hamiltonian2.e_m_to_k2cell -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_cell(%d,%d,%d,%d)" $current_bond $current_site $two $current_term]
	
	label .hamiltonian2.l_m_to_k3     -font $Font6 -text "3"
	entry .hamiltonian2.e_m_to_k3x    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_x(%d,%d,%d,%d)" $current_bond $current_site $three $current_term] 
	entry .hamiltonian2.e_m_to_k3y    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_y(%d,%d,%d,%d)" $current_bond $current_site $three $current_term]
	entry .hamiltonian2.e_m_to_k3z    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_z(%d,%d,%d,%d)" $current_bond $current_site $three $current_term]
	entry .hamiltonian2.e_m_to_k3cell -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_cell(%d,%d,%d,%d)" $current_bond $current_site $three $current_term]
	
	label .hamiltonian2.l_m_to_k4     -font $Font6 -text "4"
	entry .hamiltonian2.e_m_to_k4x    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_x(%d,%d,%d,%d)" $current_bond $current_site $four $current_term] 
	entry .hamiltonian2.e_m_to_k4y    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_y(%d,%d,%d,%d)" $current_bond $current_site $four $current_term] 
	entry .hamiltonian2.e_m_to_k4z    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_z(%d,%d,%d,%d)" $current_bond $current_site $four $current_term]
	entry .hamiltonian2.e_m_to_k4cell -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_cell(%d,%d,%d,%d)" $current_bond $current_site $four $current_term]
	
	label .hamiltonian2.l_m_to_k5     -font $Font6 -text "5"
	entry .hamiltonian2.e_m_to_k5x    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_x(%d,%d,%d,%d)" $current_bond $current_site $five $current_term]
	entry .hamiltonian2.e_m_to_k5y    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_y(%d,%d,%d,%d)" $current_bond $current_site $five $current_term]
	entry .hamiltonian2.e_m_to_k5z    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_z(%d,%d,%d,%d)" $current_bond $current_site $five $current_term]
	entry .hamiltonian2.e_m_to_k5cell -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_cell(%d,%d,%d,%d)" $current_bond $current_site $five $current_term]
	
	label .hamiltonian2.l_m_to_k6     -font $Font6 -text "6"
	entry .hamiltonian2.e_m_to_k6x    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_x(%d,%d,%d,%d)" $current_bond $current_site $six $current_term]
	entry .hamiltonian2.e_m_to_k6y    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_y(%d,%d,%d,%d)" $current_bond $current_site $six $current_term]
	entry .hamiltonian2.e_m_to_k6z    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_z(%d,%d,%d,%d)" $current_bond $current_site $six $current_term]
	entry .hamiltonian2.e_m_to_k6cell -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_cell(%d,%d,%d,%d)" $current_bond $current_site $six $current_term]
	
	label .hamiltonian2.l_m_to_k7     -font $Font6 -text "7"
	entry .hamiltonian2.e_m_to_k7x    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_x(%d,%d,%d,%d)" $current_bond $current_site $seven $current_term]
	entry .hamiltonian2.e_m_to_k7y    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_y(%d,%d,%d,%d)" $current_bond $current_site $seven $current_term]
	entry .hamiltonian2.e_m_to_k7z    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_z(%d,%d,%d,%d)" $current_bond $current_site $seven $current_term]
	entry .hamiltonian2.e_m_to_k7cell -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_cell(%d,%d,%d,%d)" $current_bond $current_site $seven $current_term]
	
	label .hamiltonian2.l_m_to_k8     -font $Font6 -text "8"
	entry .hamiltonian2.e_m_to_k8x    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_x(%d,%d,%d,%d)" $current_bond $current_site $eight $current_term]
	entry .hamiltonian2.e_m_to_k8y    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_y(%d,%d,%d,%d)" $current_bond $current_site $eight $current_term]
	entry .hamiltonian2.e_m_to_k8z    -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_z(%d,%d,%d,%d)" $current_bond $current_site $eight $current_term]
	entry .hamiltonian2.e_m_to_k8cell -relief sunken -width 2 -textvariable [format \
		"H_m_to_k_cell(%d,%d,%d,%d)" $current_bond $current_site $eight $current_term]
	
	if { $directional == 1 && $current_term <= 9} {
	    label .hamiltonian2.l_m_to_knote -font $Font5 -foreground red \
		    -text "Directional <--- " 
	} else {
	    label .hamiltonian2.l_m_to_knote -font $Font5 -foreground red \
		    -text " " 
	}
	
	label .hamiltonian2.coefflabel_m_to_k1 -font $Font6 -text "  Coeff"
	entry .hamiltonian2.coeffentry_m_to_k1 -relief sunken -width 4 -textvariable \
		[format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
		$current_site $one $current_term]
	label .hamiltonian2.coefflabel_m_to_k2 -font $Font6 -text "  Coeff"
	entry .hamiltonian2.coeffentry_m_to_k2 -relief sunken -width 4 -textvariable \
		[format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
		$current_site $two $current_term]
	label .hamiltonian2.coefflabel_m_to_k3 -font $Font6 -text "  Coeff"
	entry .hamiltonian2.coeffentry_m_to_k3 -relief sunken -width 4 -textvariable \
		[format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
		$current_site $three $current_term]
	label .hamiltonian2.coefflabel_m_to_k4 -font $Font6 -text "  Coeff"
	entry .hamiltonian2.coeffentry_m_to_k4 -relief sunken -width 4 -textvariable \
	    [format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
	    $current_site $four $current_term]
	label .hamiltonian2.coefflabel_m_to_k5 -font $Font6 -text "  Coeff"
	entry .hamiltonian2.coeffentry_m_to_k5 -relief sunken -width 4 -textvariable \
		[format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
		$current_site $five $current_term]
	label .hamiltonian2.coefflabel_m_to_k6 -font $Font6 -text "  Coeff"
	entry .hamiltonian2.coeffentry_m_to_k6 -relief sunken -width 4 -textvariable \
		[format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
		$current_site $six $current_term]
	label .hamiltonian2.coefflabel_m_to_k7 -font $Font6 -text "  Coeff"
	entry .hamiltonian2.coeffentry_m_to_k7 -relief sunken -width 4 -textvariable \
		[format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
		$current_site $seven $current_term]
	label .hamiltonian2.coefflabel_m_to_k8 -font $Font6 -text "  Coeff"
	entry .hamiltonian2.coeffentry_m_to_k8 -relief sunken -width 4 -textvariable \
		[format  "H_coefficient(%d,%d,%d,%d)" $current_bond \
		$current_site $eight $current_term]

	grid config .hamiltonian2.l_m_to_k0 \
		-column 0 -row 2 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.neigh_m_to_k \
		-column 1 -row 2 -sticky e -pady 2 -padx 2
	grid config .hamiltonian2.l_m_to_knote \
		-column 0 -row 3 -sticky w -pady 2 -padx 2
	
	if {$current_site > $unitCell_number} {
	    set current_site 1 
	}
	
	if {$current_term >= 10} {
	    set dummy1 [format \
		    "set H_m_to_k_number(%d,%d,%d) 0" $current_bond $current_site $current_term]
	    eval $dummy1 
	}
	
	set dummy1 [format \
		"set tempVar \$H_m_to_k_number(%d,%d,%d)" $current_bond $current_site $current_term]
	
	eval $dummy1 
	
	if { $tempVar >= 1 } {
	    grid config .hamiltonian2.coefflabel_m_to_k1 \
		    -column 2 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.coeffentry_m_to_k1 \
		    -column 3 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.l_m_to_k1 \
		    -column 4 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k1x \
		-column 5 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k1y \
		    -column 6 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k1z  \
		    -column 7 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k1cell \
		    -column 8 -row 2 -sticky e -pady 2 -padx 2
	} 
	if { $tempVar  >= 2 } { 
	    grid config .hamiltonian2.coefflabel_m_to_k2 \
		    -column 9 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.coeffentry_m_to_k2 \
		    -column 10 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.l_m_to_k2 \
		    -column 11  -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k2x \
		    -column 12  -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k2y \
		    -column 13 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k2z  \
		    -column 14 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k2cell \
		    -column 15 -row 2 -sticky e -pady 2 -padx 2
	} 
	if { $tempVar  >= 3 } { 
	    grid config .hamiltonian2.coefflabel_m_to_k3 \
		    -column 16 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.coeffentry_m_to_k3 \
		    -column 17 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.l_m_to_k3 \
		    -column 18  -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k3x \
		    -column 19 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k3y \
		    -column 20 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k3z \
		    -column 21 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k3cell \
		    -column 22 -row 2 -sticky e -pady 2 -padx 2
	}
	if { $tempVar >= 4 } { 
	    grid config .hamiltonian2.coefflabel_m_to_k4 \
		    -column 23 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.coeffentry_m_to_k4 \
		    -column 24 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.l_m_to_k4 \
		    -column 25  -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k4x \
		    -column 26  -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k4y \
		    -column 27 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k4z \
		    -column 28 -row 2 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k4cell \
		    -column 29 -row 2 -sticky e -pady 2 -padx 2
	} 
	if { $tempVar >= 5 } { 
	    grid config .hamiltonian2.coefflabel_m_to_k5 \
		    -column 2 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.coeffentry_m_to_k5 \
		    -column 3 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.l_m_to_k5 \
		    -column 4  -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k5x \
		    -column 5  -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k5y \
		    -column 6 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k5z \
		    -column 7 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k5cell \
		    -column 8 -row 3 -sticky e -pady 2 -padx 2
	} 
	if { $tempVar >= 6 } { 
	    grid config .hamiltonian2.coefflabel_m_to_k6 \
		    -column 9 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.coeffentry_m_to_k6 \
		    -column 10 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.l_m_to_k6 \
		    -column 11  -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k6x \
		    -column 12  -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k6y \
		    -column 13 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k6z \
		    -column 14 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k6cell \
		    -column 15 -row 3 -sticky e -pady 2 -padx 2
	} 
	if { $tempVar >= 7 } { 
	    grid config .hamiltonian2.coefflabel_m_to_k7 \
		    -column 16 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.coeffentry_m_to_k7 \
		    -column 17 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.l_m_to_k7 \
		    -column 18  -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k7x \
		    -column 19  -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k7y \
		    -column 20 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k7z \
		    -column 21 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k7cell \
		    -column 22 -row 3 -sticky e -pady 2 -padx 2
	} 
	if { $tempVar >= 8 } { 
	    grid config .hamiltonian2.coefflabel_m_to_k8 \
		    -column 23 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.coeffentry_m_to_k8 \
		    -column 24 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.l_m_to_k8 \
		-column 25 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k8x \
		    -column 26  -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k8y \
		    -column 27 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k8z \
		    -column 28 -row 3 -sticky e -pady 2 -padx 2
	    grid config .hamiltonian2.e_m_to_k8cell \
		    -column 29 -row 3 -sticky e -pady 2 -padx 2
	} 
	
    } else {
	
	set dummy1 [format \
	    "set H_m_to_k_number(%d,%d,%d) \$tempVar " $current_bond $current_site $current_term]

	eval $dummy1
	
	for {set i 1} {$i < 9} {incr i} {
	    
	    set dummy2  [format \
		    "set H_m_to_k_x(%d,%d,%d,%d) \$H_k_to_m_x(%d,%d,%d,%d)"\
		    $current_bond $current_site $i $current_term $current_bond $current_site $i $current_term ]
	    set dummy3  [format \
		    "set H_m_to_k_y(%d,%d,%d,%d)  \$H_k_to_m_y(%d,%d,%d,%d)"\
		    $current_bond $current_site $i $current_term $current_bond $current_site $i $current_term ]
	    set dummy4  [format \
		    "set H_m_to_k_z(%d,%d,%d,%d) \$H_k_to_m_z(%d,%d,%d,%d)"\
		    $current_bond $current_site $i $current_term $current_bond $current_site $i $current_term ]
	    set dummy5  [format \
		    "set H_m_to_k_cell(%d,%d,%d,%d)  \$H_k_to_m_cell(%d,%d,%d,%d)"\
		    $current_bond $current_site $i $current_term $current_bond $current_site $i $current_term ]
	    
	    eval $dummy2
	    eval $dummy3
	    eval $dummy4
	    eval $dummy5
	    
	}
    }

    return

}

proc save_procedure { } {

    global Font1 
    global Font7 
    global Font2 
    global Font3 
    global Font4 
    global Font5 
    global Font6 
    
    global script 
    global tempText
    global path
    global fname 
    global tempPath

    # top level parameters

    global output 
    global dimension  
    global spin  
    global bounding  	
    global n
    global m  
    global bonds  

    # unit cell

    global unitCell_number 
    
    global unitCell_x
    global unitCell_y
    global unitCell_z
    global unitCell_s

    global bravaisLattice_a
    global bravaisLattice_b
    global bravaisLattice_c

    global minimum 
    global maximum 
    global minimumy 
    global maximumy 
    global increment

    global latticeNeighbours_number

    global latticeNeighbours_x
    global latticeNeighbours_y
    global latticeNeighbours_z
    global latticeNeighbours_cell

    # Hamiltonian terms 
    
    global H_k_to_m_number
    global H_m_to_k_number
    global H_k_to_m_x
    global H_k_to_m_y
    global H_k_to_m_z
    global H_k_to_m_cell

    global H_m_to_k_x
    global H_m_to_k_y
    global H_m_to_k_z
    global H_m_to_k_cell
    global H_coefficient
    global restriction

    # now global initial symmetry operations
    
    global symmetry_number 
    global LatticeSymmetries_R
    global LatticeSymmetries_x
    global LatticeSymmetries_y
    global LatticeSymmetries_z

    global directional

    global solutionStrategy

    set fnameOut $path
    append fnameOut "Data/"
    append fnameOut $script

    set fileid [open $fnameOut w]
    
#   control parameters first
    
    puts $fileid [format "// control parameters"]
    puts $fileid [format "output level=%2s" $output]
    puts $fileid [format "work directory=%20s" $tempPath]
    puts $fileid [format "output file=%20s" $fname]

#   solve and plot.tcl parameters
    
    puts $fileid [format "// solve parameters now"]
    puts $fileid [format "minimum=%30.20f" $minimum]
    puts $fileid [format "maximum=%30.20f" $maximum]
    puts $fileid [format "increment=%30.20f" $increment]
    puts $fileid [format "minimumy=%30.20f" $minimumy]
    puts $fileid [format "maximumy=%30.20f" $maximumy]

#   other higher level parameters 

    puts $fileid [format "// other higher level parameters"]
    puts $fileid [format "dimension=%1s" $dimension]
    puts $fileid [format "spin=%5s" $spin]
    puts $fileid [format "bounding=%10s" $bounding]
    puts $fileid [format "n=%5s" $n]
    puts $fileid [format "m=%5s" $m]
    puts $fileid [format "bonds=%5s" $bonds]
    puts $fileid [format "restriction=%1s" $restriction]
    puts $fileid [format "solution strategy=%1s" $solutionStrategy]    

    puts $fileid [format "// the unit cell"]
    puts $fileid [format "number=%1s" $unitCell_number]

    for { set site 1 } {$site <= $unitCell_number }  {incr site} {

	set dummy1 [format "set dummyVar1 \$unitCell_x(%d)" $site]
	set dummy2 [format "set dummyVar2 \$unitCell_y(%d)" $site]
	set dummy3 [format "set dummyVar3 \$unitCell_z(%d)" $site]
	set dummy4 [format "set dummyVar4 \$unitCell_s(%d)" $site]

	eval $dummy1
	eval $dummy2
	eval $dummy3
	eval $dummy4
	
	 puts $fileid [format "%10s %10s %10s %10s" \
		 $dummyVar1 $dummyVar2 $dummyVar3 $dummyVar4]
	
    }

    puts $fileid [format "// the Bravais lattice"]
    puts $fileid [format "=%10s %10s %10s" \
	    $bravaisLattice_a(1) $bravaisLattice_a(2) $bravaisLattice_a(3)]
    puts $fileid [format "%10s %10s %10s" \
	    $bravaisLattice_b(1) $bravaisLattice_b(2) $bravaisLattice_b(3)]
    puts $fileid [format "%10s %10s %10s" \
	    $bravaisLattice_c(1) $bravaisLattice_c(2) $bravaisLattice_c(3)]
    
    
    puts $fileid [format "// the nearest-neighbours to each site"]
    puts $fileid [format "// in the unit cell"]

    for { set site 1 } {$site <= $unitCell_number }  {incr site} {
   
	set dummy1 [format "set dummyNumber \$latticeNeighbours_number(%d)" \
		$site]
	eval $dummy1

	puts $fileid [format "number=%1s" $dummyNumber]

	for { set neighbour 1 } {$neighbour <= $dummyNumber } \
		{incr neighbour} {

	    set dummy2 [format "set dummyVar1 \$latticeNeighbours_x(%d,%d)" \
		    $site $neighbour]
	    set dummy3 [format "set dummyVar2 \$latticeNeighbours_y(%d,%d)" \
		    $site $neighbour]
	    set dummy4 [format "set dummyVar3 \$latticeNeighbours_z(%d,%d)" \
		    $site $neighbour]
	    set dummy5 [format \
		    "set dummyVar4 \$latticeNeighbours_cell(%d,%d)" \
		    $site $neighbour]
	    
	    eval $dummy2
	    eval $dummy3
	    eval $dummy4
	    eval $dummy5
	    
	    puts $fileid [format "%6s %6s %6s %6s" \
		 $dummyVar1 $dummyVar2 $dummyVar3 $dummyVar4]
	}
    }

    puts $fileid [format "// symmetry operations in Cartesian coordinates."]

    puts $fileid [format "number=%6s" $symmetry_number]

    set one 1
    set two 2
    set three 3
    set four 4
    set five 5
    set six 6
    set seven 7
    set eight 8

    for { set i 1 } {$i <= $symmetry_number }  {incr i} {

	for { set j 1 } {$j <= $three }  {incr j} {
	
	    set dummy2 \
		    [format "set dummyVar1 \$LatticeSymmetries_R(%d,%d,%d)" \
		    $i $j $one]
	    set dummy3 \
		    [format "set dummyVar2 \$LatticeSymmetries_R(%d,%d,%d)" \
		    $i $j $two]
	    set dummy4 \
		    [format "set dummyVar3 \$LatticeSymmetries_R(%d,%d,%d)" \
		    $i $j $three]
	    if { $j == 1 } {
		set dummy5 \
			[format "set dummyVar4 \$LatticeSymmetries_x(%d)" \
			$i]
	    } elseif { $j == 2 } {
				set dummy5 \
			[format "set dummyVar4 \$LatticeSymmetries_y(%d)" \
			$i]
	    } else {
		set dummy5 \
			[format "set dummyVar4 \$LatticeSymmetries_z(%d)" \
			$i]
	    }

	    eval $dummy2
	    eval $dummy3
	    eval $dummy4
	    eval $dummy5
	    
	    puts $fileid [format "%10s %10s %10s %10s" \
		    $dummyVar1 $dummyVar2 $dummyVar3 $dummyVar4]
	    
	}
    }

#   Hamiltonian terms 

    puts $fileid \
	    [format "// Information regardin the Hamiltonian in terms of:"]

    puts $fileid [format "// Hamiltonian types."]
    
    puts $fileid [format "directional=%1s" $directional]
    
    for { set bond 1 } {$bond <= $two }  {incr bond} {
	
	for { set site 1 } {$site <= $unitCell_number }  {incr site} {
	    
	    for { set term 1 } {$term <= 13 }  {incr term} {


		puts $fileid [format "// bond %1s site %1s term %2s" \
			$bond $site $term]

		if {$term >= 10 } {
		    
		    set dummy7 \
			    [format "set dummyVar5 \$H_coefficient(%d,%d,%d,%d)" \
			    $bond $site $one $term]
		    
		    eval $dummy7
		    puts $fileid [format "number=1 %f" $dummyVar5]
		    
		} else { 
		    if { $directional == 1 } {
			
			set dummy1 \
				[format "set dummyNumber1 \$H_k_to_m_number(%d,%d,%d)" \
				$bond $site $term]
			eval $dummy1
			
			set dummy2 \
				[format "set dummyNumber2 \$H_m_to_k_number(%d,%d,%d)" \
				$bond $site $term]
			eval $dummy2
			
			puts $fileid [format "number=%1s" $dummyNumber1]
			
			for { set friend 1 } {$friend <= $dummyNumber1 } \
				{incr friend} { 
			    
			    set dummy3 \
				    [format "set dummyVar1 \$H_k_to_m_x(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy4 \
				    [format "set dummyVar2 \$H_k_to_m_y(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy5 \
				    [format "set dummyVar3 \$H_k_to_m_z(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy6 \
				    [format "set dummyVar4 \$H_k_to_m_cell(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy7 \
				    [format "set dummyVar5 \$H_coefficient(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    
			    eval $dummy3
			    eval $dummy4
			    eval $dummy5
			    eval $dummy6
			    eval $dummy7
			    
			    puts $fileid [format "%6s %6s %6s %6s %f" \
				    $dummyVar1 $dummyVar2 $dummyVar3 \
				    $dummyVar4 $dummyVar5 ]
			    
			    
			}
			
			puts $fileid [format "number=%1s" $dummyNumber2]
			
			for { set friend 1 } {$friend <= $dummyNumber2 } \
				{incr friend} { 
			    
			    set dummy3 \
				    [format "set dummyVar1 \$H_m_to_k_x(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy4 \
				    [format "set dummyVar2 \$H_m_to_k_y(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy5 \
				    [format "set dummyVar3 \$H_m_to_k_z(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy6 \
				    [format "set dummyVar4 \$H_m_to_k_cell(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy7 \
				    [format "set dummyVar5 \$H_coefficient(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    
			    eval $dummy3
			    eval $dummy4
			    eval $dummy5
			    eval $dummy6
			    eval $dummy7
			    
			    puts $fileid [format "%6s %6s %6s %6s %f" \
				    $dummyVar1 $dummyVar2 $dummyVar3 \
				    $dummyVar4 $dummyVar5 ]
			    
			    
			}
			
		    } else {
			
			
			set dummy1 \
				[format "set dummyNumber1 \$H_k_to_m_number(%d,%d,%d)" \
				$bond $site $term]
			eval $dummy1
			
			puts $fileid [format "number=%1s" $dummyNumber1]
			
			for { set friend 1 } {$friend <= $dummyNumber1 } \
				{incr friend} { 
			    
			    set dummy3 \
				    [format "set dummyVar1 \$H_k_to_m_x(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy4 \
				    [format "set dummyVar2 \$H_k_to_m_y(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy5 \
				    [format "set dummyVar3 \$H_k_to_m_z(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy6 \
				    [format "set dummyVar4 \$H_k_to_m_cell(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    set dummy7 \
				    [format "set dummyVar5 \$H_coefficient(%d,%d,%d,%d)" \
				    $bond $site $friend $term]
			    
			    eval $dummy3
			    eval $dummy4
			    eval $dummy5
			    eval $dummy6
			    eval $dummy7
			    
			    puts $fileid [format "%6s %6s %6s %6s %f" \
				    $dummyVar1 $dummyVar2 $dummyVar3 \
				    $dummyVar4 $dummyVar5 ]
			    
			    
			}
		    }
		}
	    }
	}		    
    }

    puts $fileid [format "// end of input file!"]

    flush $fileid
    close $fileid

    return

}

proc load_procedure { } {

    global Font1 
    global Font7 
    global Font2 
    global Font3 
    global Font4 
    global Font5 
    global Font6 
    
    global script 
    global tempText
    global path
    global fname 
    global restriction
    global tempPath

    # top level parameters

    global output 
    global dimension  
    global spin  
    global bounding  	
    global n
    global m  
    global bonds  

    # unit cell

    global unitCell_number 
    
    global unitCell_x
    global unitCell_y
    global unitCell_z
    global unitCell_s

    global bravaisLattice_a
    global bravaisLattice_b
    global bravaisLattice_c

    global minimum 
    global maximum 
    global minimumy 
    global maximumy 
    global increment

    global latticeNeighbours_number

    global latticeNeighbours_x
    global latticeNeighbours_y
    global latticeNeighbours_z
    global latticeNeighbours_cell

    # Hamiltonian terms 
    
    global H_k_to_m_number
    global H_m_to_k_number
    global H_k_to_m_x
    global H_k_to_m_y
    global H_k_to_m_z
    global H_k_to_m_cell

    global H_m_to_k_x
    global H_m_to_k_y
    global H_m_to_k_z
    global H_m_to_k_cell
    global H_coefficient

    # now global initial symmetry operations
    
    global symmetry_number 
    global LatticeSymmetries_R
    global LatticeSymmetries_x
    global LatticeSymmetries_y
    global LatticeSymmetries_z

    global directional
    global solutionStrategy

    set fnameOut $path
    append fnameOut "Data/"
    append fnameOut $script

    set fileid [open $fnameOut r]
    
#   control parameters first
# ToDo: better call procedure, searching for a expected string 
    
    set dummy 0
    while {! [eof $fileid]} {      ;# Joerg Nov05: ignore comments
      gets $fileid tempString
      set dummy [scan $tempString "output level=%2s" output]
      if {$dummy} {break;}
    }
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for output"
    }

    gets $fileid tempString
    set dummy [scan $tempString "work directory=%20s" tempPath]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for work directory"
    }

    gets $fileid tempString
    set dummy [scan $tempString "output file=%20s" fname]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for output file name"
    }

#   solve.C parameters and plot.tcl parameters

    gets $fileid tempString
    gets $fileid tempString
    set dummy [scan $tempString "minimum=%f" minimum]
    gets $fileid tempString
    set dummy [scan $tempString "maximum=%f" maximum]
    gets $fileid tempString
    set dummy [scan $tempString "increment=%f" increment]
    gets $fileid tempString
    set dummy [scan $tempString "minimumy=%f" minimumy]
    gets $fileid tempString
    set dummy [scan $tempString "maximumy=%f" maximumy]

#   run-time parameters


    gets $fileid 
    gets $fileid tempString
    set dummy [scan $tempString "dimension=%1s" dimension]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for dimension"
    }
    gets $fileid tempString
    set dummy [scan $tempString "spin=%5s" spin]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for spin"
    }
    gets $fileid tempString
    set dummy [scan $tempString "bounding=%10s" bounding]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for bounding"
    }
    gets $fileid tempString
    set dummy [scan $tempString "n=%5s" n]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter subn-m n=?"
    }
    gets $fileid tempString
    set dummy [scan $tempString "m=%5s" m]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter subn-m m=?"
    }
    gets $fileid tempString
    set dummy [scan $tempString "bonds=%5s" bonds]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for bonds?"
    }

    gets $fileid tempString
    set dummy [scan $tempString "restriction=%1s" restriction]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for restriction?"
    }
    
    gets $fileid tempString
    set dummy [scan $tempString "solution strategy=%1s" solutionStrategy]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for restriction?"
    }

    gets $fileid tempString
    gets $fileid tempString
    set dummy [scan $tempString "number=%1s" unitCell_number]

    for { set site 1 } {$site <= $unitCell_number }  {incr site} {

	gets $fileid tempString
	set dummy [scan $tempString "%10s %10s %10s %10s" \
		dummyVar1 dummyVar2 dummyVar3 dummyVar4]

	if { $dummy == 0 } {
	    puts "Error in scanning in parameter for unit Cell variables"
	}

	set dummy1 [format "set unitCell_x(%d) \$dummyVar1" $site]
	set dummy2 [format "set unitCell_y(%d) \$dummyVar2" $site]
	set dummy3 [format "set unitCell_z(%d) \$dummyVar3" $site]
	set dummy4 [format "set unitCell_s(%d) \$dummyVar4" $site]

	eval $dummy1
	eval $dummy2
	eval $dummy3
	eval $dummy4

    }

    gets $fileid tempString
    gets $fileid tempString
    set dummy [scan $tempString "=%10s %10s %10s" \
	    bravaisLattice_a(1) bravaisLattice_a(2) bravaisLattice_a(3)]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for unit bravais a"
    }
    gets $fileid tempString
    set dummy [scan $tempString "%10s %10s %10s" \
	    bravaisLattice_b(1) bravaisLattice_b(2) bravaisLattice_b(3)]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for unit bravais b"
    }
    gets $fileid tempString
    set dummy [scan $tempString "%10s %10s %10s" \
	    bravaisLattice_c(1) bravaisLattice_c(2) bravaisLattice_c(3)]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for unit bravais c"
    }
    
    
    gets $fileid tempString
    gets $fileid tempString

    for { set site 1 } {$site <= $unitCell_number }  {incr site} {
   	
	gets $fileid tempString
	set dummy [scan $tempString "number=%1s" dummyNumber]
	if { $dummy == 0 } {
	    puts "Error in scanning in number of lattice neighbours"
	}
	
	set dummy1 [format "set latticeNeighbours_number(%d) \$dummyNumber" \
		$site]
	eval $dummy1

	for { set neighbour 1 } {$neighbour <= $dummyNumber } \
		{incr neighbour} {

	    gets $fileid tempString
	    set dummy [scan $tempString "%6s %6s %6s %6s" \
		    dummyVar1 dummyVar2 dummyVar3 dummyVar4]
	    
	    if { $dummy == 0 } {
		puts "Error in scanning in parameters for lattice neighbours"
	    }

	    set dummy2 [format "set latticeNeighbours_x(%d,%d) \$dummyVar1" \
		    $site $neighbour]
	    set dummy3 [format "set latticeNeighbours_y(%d,%d) \$dummyVar2" \
		    $site $neighbour]
	    set dummy4 [format "set latticeNeighbours_z(%d,%d) \$dummyVar3 " \
		    $site $neighbour]
	    set dummy5 [format \
		    "set latticeNeighbours_cell(%d,%d) \$dummyVar4 " \
		    $site $neighbour]
	    
	    eval $dummy2
	    eval $dummy3
	    eval $dummy4
	    eval $dummy5

	}
    }

    gets $fileid tempString

    gets $fileid tempString
    set dummy [scan $tempString "number=%6s" symmetry_number]
    if { $dummy == 0 } {
	puts "Error in scanning in number of symmetry operations"
    }
    
    set one 1
    set two 2
    set three 3
    set four 4
    set five 5
    set six 6
    set seven 7
    set eight 8

    for { set i 1 } {$i <= $symmetry_number }  {incr i} {

	for { set j 1 } {$j <= $three }  {incr j} {
	
	    gets $fileid tempString
	    set dummy [scan $tempString "%10s %10s %10s %10s" \
		    dummyVar1 dummyVar2 dummyVar3 dummyVar4]
	    
	    if { $dummy == 0 } {
		puts "Error in scanning in the symmetry operations"
	    }

	    set dummy2 \
		    [format "set LatticeSymmetries_R(%d,%d,%d) \$dummyVar1 " \
		    $i $j $one]
	    set dummy3 \
		    [format "set LatticeSymmetries_R(%d,%d,%d) \$dummyVar2 " \
		    $i $j $two]
	    set dummy4 \
		    [format "set LatticeSymmetries_R(%d,%d,%d) \$dummyVar3 " \
		    $i $j $three]
	    if { $j == 1 } {
		set dummy5 \
			[format "set LatticeSymmetries_x(%d) \$dummyVar4 " \
			$i]
	    } elseif { $j == 2 } {
				set dummy5 \
			[format "set LatticeSymmetries_y(%d) \$dummyVar4 " \
			$i]
	    } else {
		set dummy5 \
			[format "set LatticeSymmetries_z(%d) \$dummyVar4 " \
			$i]
	    }

	    eval $dummy2
	    eval $dummy3
	    eval $dummy4
	    eval $dummy5
	    
	    
	}
    }

#   Hamiltonian terms 

    gets $fileid tempString
    gets $fileid tempString
    gets $fileid tempString
    
    set dummy [scan $tempString "directional=%1s" directional]
    if { $dummy == 0 } {
	puts "Error in scanning in parameter for `directional'"
    }  

    for { set bond 1 } {$bond <= $two }  {incr bond} {
	
	for { set site 1 } {$site <= $unitCell_number }  {incr site} {
	    
	    for { set term 1 } {$term <= 13 }  {incr term} {

		gets $fileid tempString

		if {$term >= 10 } {
		    
		    gets $fileid tempString
		    set dummy [scan $tempString "number=1 %f" dummyVar5]
		    if { $dummy == 0 } {
			puts "Error in scanning in coefficient term >= 10"
		    }
		    
		    set dummy7 \
			    [format "set H_coefficient(%d,%d,%d,%d) \$dummyVar5" \
			    $bond $site $one $term]
		    eval $dummy7		

		} else {

		    if { $directional == 1 } {
			
			gets $fileid tempString
			set dummy [scan $tempString "number=%1s" dummyNumber1]
			
			set dummy1 \
				[format "set H_k_to_m_number(%d,%d,%d) \$dummyNumber1" \
				$bond $site $term]
			eval $dummy1
			
			for { set friend 1 } {$friend <= $dummyNumber1 } \
				{incr friend} { 
			    
			    gets $fileid tempString
			    set dummy [scan $tempString "%6s %6s %6s %6s %f" \
				    dummyVar1 dummyVar2 dummyVar3 \
				    dummyVar4 dummyVar5 ]
			    
			    set dummy3 \
				    [format "set H_k_to_m_x(%d,%d,%d,%d) \$dummyVar1" \
				    $bond $site $friend $term]
			    set dummy4 \
				    [format "set H_k_to_m_y(%d,%d,%d,%d) \$dummyVar2" \
				    $bond $site $friend $term]
			    set dummy5 \
				    [format "set H_k_to_m_z(%d,%d,%d,%d) \$dummyVar3" \
				    $bond $site $friend $term]
			    set dummy6 \
				    [format "set H_k_to_m_cell(%d,%d,%d,%d) \$dummyVar4" \
				    $bond $site $friend $term]
			    
			    eval $dummy3
			    eval $dummy4
			    eval $dummy5
			    eval $dummy6
			    
			    set dummy7 \
				    [format "set H_coefficient(%d,%d,%d,%d) \$dummyVar5 " \
				    $bond $site $friend $term]
			    eval $dummy7			
			}
			
			gets $fileid tempString
			set dummy [scan $tempString "number=%1s" dummyNumber2]
			set dummy2 \
				[format "set H_m_to_k_number(%d,%d,%d) \$dummyNumber2" \
				$bond $site $term]
			eval $dummy2
			
			for { set friend 1 } {$friend <= $dummyNumber2 } \
				{incr friend} { 
			    
			    gets $fileid tempString
			    set dummy [scan $tempString "%6s %6s %6s %6s %f" \
				    dummyVar1 dummyVar2 dummyVar3 \
				    dummyVar4 dummyVar5 ]
			    
			    set dummy3 \
				    [format "set H_m_to_k_x(%d,%d,%d,%d) \$dummyVar1" \
				    $bond $site $friend $term]
			    set dummy4 \
				    [format "set H_m_to_k_y(%d,%d,%d,%d) \$dummyVar2" \
				    $bond $site $friend $term]
			    set dummy5 \
				    [format "set H_m_to_k_z(%d,%d,%d,%d) \$dummyVar3" \
				    $bond $site $friend $term]
			    set dummy6 \
				    [format "set H_m_to_k_cell(%d,%d,%d,%d) \$dummyVar4" \
				    $bond $site $friend $term]
			    
			    eval $dummy3
			    eval $dummy4
			    eval $dummy5
			    eval $dummy6
			    set dummy7 \
				    [format "set H_coefficient(%d,%d,%d,%d) \$dummyVar5 " \
				    $bond $site $friend $term]
			    eval $dummy7			
			}
			
		    } else {
			
			gets $fileid tempString
			set dummy [scan $tempString "number=%1s" dummyNumber1]
			set dummy1 \
				[format "set H_k_to_m_number(%d,%d,%d) \$dummyNumber1" \
				$bond $site $term]
			eval $dummy1
			set dummy1 \
				[format "set H_m_to_k_number(%d,%d,%d) \$dummyNumber1" \
				$bond $site $term]
			eval $dummy1
			
			for { set friend 1 } {$friend <= $dummyNumber1 } \
				{incr friend} { 
			    
			    gets $fileid tempString
			    set dummy [scan $tempString "%6s %6s %6s %6s %f" \
				    dummyVar1 dummyVar2 dummyVar3 \
				    dummyVar4 dummyVar5 ]
			    
			    set dummy3 \
				    [format "set H_k_to_m_x(%d,%d,%d,%d) \$dummyVar1" \
				    $bond $site $friend $term]
			    set dummy4 \
				    [format "set H_k_to_m_y(%d,%d,%d,%d) \$dummyVar2" \
				    $bond $site $friend $term]
			    set dummy5 \
				    [format "set H_k_to_m_z(%d,%d,%d,%d) \$dummyVar3" \
				    $bond $site $friend $term]
			    set dummy6 \
				    [format "set H_k_to_m_cell(%d,%d,%d,%d) \$dummyVar4" \
				    $bond $site $friend $term]
			    
			    eval $dummy3
			    eval $dummy4
			    eval $dummy5
			    eval $dummy6
			    
			    set dummy3 \
				    [format "set H_m_to_k_x(%d,%d,%d,%d) \$dummyVar1" \
				    $bond $site $friend $term]
			    set dummy4 \
				    [format "set H_m_to_k_y(%d,%d,%d,%d) \$dummyVar2" \
				    $bond $site $friend $term]
			    set dummy5 \
				    [format "set H_m_to_k_z(%d,%d,%d,%d) \$dummyVar3" \
				    $bond $site $friend $term]
			    set dummy6 \
				    [format "set H_m_to_k_cell(%d,%d,%d,%d) \$dummyVar4" \
				    $bond $site $friend $term]
			    
			    eval $dummy3
			    eval $dummy4
			    eval $dummy5
			    eval $dummy6
			    set dummy7 \
				    [format "set H_coefficient(%d,%d,%d,%d) \$dummyVar5 " \
				    $bond $site $friend $term]
			    eval $dummy7			
			}
		    }
		}
	    }
	}		    
    }

    close $fileid

    refresh_panel 
    refresh_hamiltonian1
    refresh_hamiltonian2
    refresh_symmetry

    return

}

if { $script != "default.ccm"} {

    set fnameOut $path
    append fnameOut "Data/"
    append fnameOut $script

    if { [file exists $fnameOut] == 1 } {
	load_procedure
    } else {
	puts "Script File doesn't exist => default values used!\n"
    }
}
